//========================================================================================
//
//	File:				BmpPart.r
//	Release Version:	$ 1.0d11 $
//
//	Author:				Henri Lamiraux
//
//	Copyright:	(c) 1993-95 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#define SystemSevenOrBetter 1			// we want the extended types
#define	SystemSevenOrLater	1			// Types.r uses this variable

#include "Types.r"
#include "SysTypes.r"
#include "CodeFragmentTypes.r"

#ifndef __ODTYPES_R__
#include "ODTypes.r"
#endif

#ifndef BMPDEF_H
#include "BmpDef.h"
#endif

//-------------------------------------------------------------------------------------
// cfrg Resource
//-------------------------------------------------------------------------------------

resource 'cfrg' (0) {
	{	/* array memberArray: 2 elements */
		/* [1] */
#ifdef FW_BUILD_MAC68K
		kMotorola,
#else
		kPowerPC,
#endif
		kFullLib,
		kNoVersionNum,
		kNoVersionNum,
		kDefaultStackSize,
		kNoAppSubFolder,
		kIsLib,
		kOnDiskFlat,
		kZeroOffset,
		kWholeFork,
		kODFBitmapEditor,
		/* [2] */
#ifdef FW_BUILD_MAC68K
		kMotorola,
#else
		kPowerPC,
#endif
		kFullLib,
		kNoVersionNum,
		kNoVersionNum,
		kDefaultStackSize,
		kNoAppSubFolder,
		kIsLib,
		kOnDiskFlat,
		kZeroOffset,
		kWholeFork,
		"ODFBmp"
	}
};

//-------------------------------------------------------------------------------------
// NMAP Resources
//-------------------------------------------------------------------------------------

resource kODNameMappings (kKindCategoryMapId) {
	kODKind,
	{	/* array Types: 1 elements */
		/* [1] */
		kODFBitmapKind,
		kODIsAnISOStringList
		{
			{	/* array ClassIDs: 1 elements */
				/* [1] */
				kODCategoryPainting
			}
		}
	}
};

resource kODNameMappings (kEditorKindMapId) {
	kODEditorKinds,
	{	/* array Types: 1 elements */
		/* [1] */
		kODFBitmapEditor,
		kODIsAnISOStringList
		{
			{	/* array ClassIDs: 1 elements */
				/* [1] */
				kODFBitmapKind
			}
		}
	}
};

resource kODNameMappings (kEditorUserStringMapId) {
	kODEditorUserString,
	{	/* array Types: 1 elements */
		/* [1] */
		kODFBitmapEditor,
		kODIsINTLText
		{
			smRoman,
			langEnglish,
			kODFBitmapEditorUserString
		}
	}
};

resource kODNameMappings (kKindUserStringMapId) {
	kODKindUserString,
	{	/* array Types: 1 elements */
		/* [1] */
		kODFBitmapKind,
		kODIsINTLText
		{
			smRoman,
			langEnglish,
			kODFBitmapKindUserString
		}
	}
};

resource kODNameMappings (kCategoryUserStringMapId) {
	kODCategoryUserString,
	{	/* array Types: 1 elements */
		/* [1] */
		kODCategoryPainting,
		kODIsINTLText
		{
			smRoman,
			langEnglish,
			kODFBitmapCategoryUserString
		}
	}
};

resource kODNameMappings (kOldMacOSTypeMapId) {
	kODKindOldMacOSType,
	{	/* array KeyList: 1 elements */
		/* [1] */
		kODFBitmapKind,
		kODIsMacOSType {
			kODFBitmapOSType
		}
	}
};

resource kODNameMappings (kEditorPlatformKinds) {
	kODEditorPlatformKind,
	{	/* array KeyList: 1 elements */
		/* [1] */
		kODFBitmapEditor,
		kODIsPltfmTypeSpac {
			/* array PltfmTypeSpacList: 1 elements */
			{
				/* [1] */
				kODPlatformFileType, 
				kPICTOSType, 
				smRoman, 
				langEnglish, 
				kDragKindUserString1, 
				kODCategoryPainting,
				/* [2] */
				kODPlatformDataType, 
				kPICTOSType, 
				smRoman, 
				langEnglish, 
				kDragKindUserString2, 
				kODCategoryPainting
			}
		}
	}
};

include "Image.Pict" not 'ckid';
include "MacIcons.rsrc" not 'ckid';
include "MacAbout.rsrc" not 'ckid';
