//==========================================================
//
//	File:				ButtonDef.h
//	Release Version:	$ 1.0d9 $
//
//	Author:				M.Boetcher
//
//	Copyright:	(c) 1993-95 by Apple Computer, Inc., all rights reserved.
//
//==========================================================

#ifndef BUTTONDEF_H
#define BUTTONDEF_H

// Uncomment the following three lines, and define them appropriately!!
// If your part can be a container for other parts, define FW_SUPPORTS_EMBEDDING
// to be 1.  Otherwise define it to be 0.
// If your part defines any ODExtensions, define FW_SUPPORTS_EXTENSIONS to be
// 1 to enable the extensions manager.  Otherwise, define it to be 0.
// If your part is scriptable, define FW_SUPPORTS_SCRIPTING to be 1. Otherwise,
// define it to be zero.  Note that if your part is scriptable is must support
// extensions, so FW_SUPPORTS_EXTENSIONS must be defined to be 1.

#define FW_SUPPORTS_EMBEDDING 0
#define FW_SUPPORTS_EXTENSIONS 0
#define FW_SUPPORTS_SCRIPTING 0

#ifndef FW_SUPPORTS_EMBEDDING
#error You must define FW_SUPPORTS_EMBEDDING to be 0 or 1 (immediately above)
#endif

#ifndef FW_SUPPORTS_EXTENSIONS
#error You must define FW_SUPPORTS_EXTENSIONS to be 0 or 1 (immediately above)
#endif

#ifndef FW_SUPPORTS_SCRIPTING
#error You must define FW_SUPPORTS_SCRIPTING to be 0 or 1 (immediately above)
#endif

// Kind
#define kODFButtonKind "Apple:ODFExamples:Kind:ODFButton"

// Class ID
#define kODFButtonEditor "ODFExamples::ODFButton"

// Presentation
#define kODFButtonPresentation "Apple:Presentation:ODFButton"

// Editor User String
#define kODFButtonEditorUserString "ODFButton 1.0d11"

// Kind User String
#define kODFButtonKindUserString "ODF Button Example"

// Category User String
#define kODFButtonCategoryUserString "Control"

// Button OSType
#define kODFButtonOSType 'DFUD'

// Sound OSType
#define kMacSoundOSType 'snd '

// Sound Data Type
#define kODFSoundOSType "Apple:OSType:Scrap:snd "

// Data Interchange Types
// This is bad we need to change that
#define kSoundScrapKind "+//ISO 9070/ANSI::113722::US::CI LABS::MacOS:ScrapType:snd "
#define kScriptScrapKind "+//ISO 9070/ANSI::113722::US::CI LABS::MacOS:ScrapType:scpt"
#define kSoundFileKind  "+//ISO 9070/ANSI::113722::US::CI LABS::MacOS:FileType:sfil"
#define kScriptFileKind  "+//ISO 9070/ANSI::113722::US::CI LABS::MacOS:FileType:osas"

// Part Icon
#define kPartIconID 128

#define kKindCategoryMapId			128
#define kEditorKindMapId			kKindCategoryMapId + 1
#define kEditorUserStringMapId		kEditorKindMapId + 1
#define kKindUserStringMapId		kEditorUserStringMapId + 1
#define kCategoryUserStringMapId	kKindUserStringMapId + 1
#define kOldMacOSTypeMapId			kCategoryUserStringMapId + 1
#define kEditorPlatformKinds		kOldMacOSTypeMapId + 1

#endif

