//========================================================================================
//
//	File:				ClockDef.h
//	Release Version:	$ 1.0d11 $
//
//	Author:				Lonnie Millett
//
//	Copyright:	(c) 1993-95 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef CLOCKDEF_H
#define CLOCKDEF_H

// Uncomment the following three lines, and define them appropriately!!
// If your part can be a container for other parts, define FW_SUPPORTS_EMBEDDING
// to be 1.  Otherwise define it to be 0.
// If your part defines any ODExtensions, define FW_SUPPORTS_EXTENSIONS to be
// 1 to enable the extensions manager.  Otherwise, define it to be 0.
// If your part is scriptable, define FW_SUPPORTS_SCRIPTING to be 1. Otherwise,
// define it to be zero.  Note that if your part is scriptable is must support
// extensions, so FW_SUPPORTS_EXTENSIONS must be defined to be 1.

#define FW_SUPPORTS_EMBEDDING 0
#define FW_SUPPORTS_EXTENSIONS 0
#define FW_SUPPORTS_SCRIPTING 0

#ifndef FW_SUPPORTS_EMBEDDING
#error You must define FW_SUPPORTS_EMBEDDING to be 0 or 1 (immediately above)
#endif

#ifndef FW_SUPPORTS_EXTENSIONS
#error You must define FW_SUPPORTS_EXTENSIONS to be 0 or 1 (immediately above)
#endif

#ifndef FW_SUPPORTS_SCRIPTING
#error You must define FW_SUPPORTS_SCRIPTING to be 0 or 1 (immediately above)
#endif

// Kind
#define kODFClockKind "Apple:ODFExamples:Kind:ODFClock"

// Class ID
#define kODFClockEditor "ODFExamples::ODFClock"

// Editor User String
#define kODFClockEditorUserString "ODFClock 1.0d11"

// Kind User String
#define kODFClockKindUserString "ODF Clock Example"

// Category User String
#define kODFClockCategoryUserString "Time"

// Clock OSType
#define kODFClockOSType 'DFCD'

// Part Icon
#define kPartIconID 128

#define kKindCategoryMapId			128
#define kEditorKindMapId			kKindCategoryMapId+1
#define kEditorUserStringMapId		kEditorKindMapId+1
#define kKindUserStringMapId		kEditorUserStringMapId+1
#define kCategoryUserStringMapId	kKindUserStringMapId+1
#define kOldMacOSTypeMapId			kCategoryUserStringMapId+1

// Strings
#define kClockMenuStrings 1000

#define kClockMenuString 1
#define kClockAnalogMenuString 2
#define kClockDigitalMenuString 3
#define kClockTickMenuString 4
#define kClockChimeMenuString 5
#define kClockPlaySoundMenuString 6

#define kClockFaceStrings 1002
#define kClockDigitalWidthString 1
#define kClockOpenDocString 2

// Sounds
#define kClockChime 1000
#define kClockTick 1001

#endif

