//========================================================================================
//
//	File:				AlgnObFr.h
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef ALGNOBFR_H
#define ALGNOBFR_H

// ----- Framewrk Layer -----

#ifndef FWFRAME_H
#include "FWFrame.h"
#endif

#ifndef FWGADGET_H
#include "FWGadget.h"
#endif

// ----- Foundation Layer -----

#ifndef FWMFCONN_H
#include "FWMFConn.h"
#endif

//========================================================================================
// Foward declarations
//========================================================================================

class FW_CLASS_ATTR CDrawPart;

//========================================================================================
// CLASS CAlignObjectsFrame
//========================================================================================

class FW_CLASS_ATTR CAlignObjectsFrame : public FW_CFrame
{
//----------------------------------------------------------------------------------------
// Constants
//
public:
	static const ODID kOkButtonId;
	static const ODID kCancelButtonId;
	static const ODID kTopToBottomClusterId;
	static const ODID kLeftToRightClusterId;
	static const ODID kNoneId;
	static const ODID kTopEdgesId;
	static const ODID kCenterId;
	static const ODID kBottomEdgesId;
	static const ODID kDistributeSpaceId;
	static const ODID kSampleAlignmentId;

//----------------------------------------------------------------------------------------
// Initialization/destruction
//
public:
	CAlignObjectsFrame(Environment* ev, ODFrame* odFrame, CDrawPart* drawPart);
	virtual ~ CAlignObjectsFrame();

	virtual void		CreateGadgetLayout();

	virtual void 		Draw(Environment* ev, ODFacet* odFacet, ODShape* invalidShape);
	
private:
	void				HandleButtonPressed(const FW_CNotification& notification);

private:
	CDrawPart*		fDrawPart;
	FW_TMemberFunctionConnection<CAlignObjectsFrame> fConnection;
};

//========================================================================================
// CLASS CSampleAlignmentGadget
//========================================================================================

class CSampleAlignmentGadget : public FW_CGadget
{
public:
	FW_DECLARE_CLASS

// ----- Initialization/destruction

public:
	CSampleAlignmentGadget(Environment* ev, 
							const FW_CClassInfo& classInfo, FW_CFrame* frame, ODID id,
			  			   	const FW_CPoint& location, const FW_CPoint& size);
	CSampleAlignmentGadget(Environment* ev, 
							const FW_CClassInfo& classInfo, FW_CGadget* enclosure, ODID id,
						   	const FW_CPoint& location, const FW_CPoint& size);
	virtual ~ CSampleAlignmentGadget();

	virtual void		Draw(Environment* ev, const FW_CGadgetContext& gc);
};

#endif
