//========================================================================================
//
//	File:				DrawDef.h
//	Release Version:	$ 1.0d11 $
//
//	Author:				Henri Lamiraux
//
//	Copyright:	 1993, 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef DRAWDEF_H
#define DRAWDEF_H

// Uncomment the following three lines, and define them appropriately!!
// If your part can be a container for other parts, define FW_SUPPORTS_EMBEDDING
// to be 1.  Otherwise define it to be 0.
// If your part defines any ODExtensions, define FW_SUPPORTS_EXTENSIONS to be
// 1 to enable the extensions manager.  Otherwise, define it to be 0.
// If your part is scriptable, define FW_SUPPORTS_SCRIPTING to be 1. Otherwise,
// define it to be zero.  Note that if your part is scriptable is must support
// extensions, so FW_SUPPORTS_EXTENSIONS must be defined to be 1.

#define FW_SUPPORTS_EMBEDDING 1
#define FW_SUPPORTS_EXTENSIONS 0
#define FW_SUPPORTS_SCRIPTING 0

#ifndef FW_SUPPORTS_EMBEDDING
#error You must define FW_SUPPORTS_EMBEDDING to be 0 or 1 (immediately above)
#endif

#ifndef FW_SUPPORTS_EXTENSIONS
#error You must define FW_SUPPORTS_EXTENSIONS to be 0 or 1 (immediately above)
#endif

#ifndef FW_SUPPORTS_SCRIPTING
#error You must define FW_SUPPORTS_SCRIPTING to be 0 or 1 (immediately above)
#endif

// Kind
#define kODFDrawKind "+//ISO 9070/ANSI::113722::US::CI LABS::Apple:ODFExamples:Kind:ODFDraw"

// Class ID
#define kODFDrawEditor "ODFExamples::ODFDraw"

// Editor User String
#define kODFDrawEditorUserString "ODFDraw 1.0d11"

// Kind User String
#define kODFDrawKindUserString "ODF Draw Example"

// Category User String
#define kODFDrawCategoryUserString "2DGraphics"

// Draw OSType
#define kODFDrawOSType 'DFDD'

// Icon ID
#define kPartIconID					128

// NMAP ID
#define kKindCategoryMapId			128
#define kEditorKindMapId			kKindCategoryMapId + 1
#define kEditorUserStringMapId		kEditorKindMapId + 1
#define kKindUserStringMapId		kEditorUserStringMapId + 1
#define kCategoryUserStringMapId	kKindUserStringMapId + 1
#define kOldMacOSTypeMapId			kCategoryUserStringMapId + 1
#define kEditorPlatformKinds		kOldMacOSTypeMapId + 1

// Frame Presentations
#define kMainPresentation			"Apple:Presentation:DrawPart:Main"
#define kPalettePresentation		"Apple:Presentation:DrawPart:Palette"
#define kPatternPresentation		"Apple:Presentation:DrawPart:Pattern"
#define kToolPresentation			"Apple:Presentation:DrawPart:Tool"
#define kAlignObjectsPresentation	"Apple:Presentation:DrawPart:AlignObjects"

// ----- type -----
#define kPublishFormat	"Apple:Publish:Draw"


// ----- Menu Strings ID -----
#define kMenuStrings 1000

#define kArrangeStr				1
#define kMoveForwardStr			2
#define kMoveToFrontStr			3
#define kMoveBackwardStr		kMoveToFrontStr + 1
#define kMoveToBackStr			kMoveBackwardStr + 1
#define kAlignToGridStr			kMoveToBackStr + 1
#define kAlignObjectsStr		kAlignToGridStr + 1
#define kRotateStr				kAlignObjectsStr + 1
#define kFlipHorizontalStr		kRotateStr + 1
#define kFlipVerticalStr		kFlipHorizontalStr + 1
#define kGroupStr				kFlipVerticalStr + 1
#define kUngroupStr				kGroupStr + 1
#define kLockStr				kUngroupStr + 1
#define kUnlockStr				kLockStr + 1
#define kSizeStr				kUnlockStr + 1
#define k1PixelStr				kSizeStr + 1
#define k2PixelsStr				k1PixelStr + 1
#define k3PixelsStr				k2PixelsStr + 1
#define k4PixelsStr				k3PixelsStr + 1
#define k5PixelsStr				k4PixelsStr + 1
#define kOptionsStr				k5PixelsStr + 1
#define kHideRulersStr			kOptionsStr + 1
#define kShowRulersStr			kHideRulersStr + 1
#define kHideGraphicsGridStr	kShowRulersStr + 1
#define kShowGraphicsGridStr	kHideGraphicsGridStr + 1
#define kTurnAutoGridOnStr		kShowGraphicsGridStr + 1
#define kTurnAutoGridOffStr		kTurnAutoGridOnStr + 1
#define kUnitsStr				kTurnAutoGridOffStr + 1
#define kInchStr				kUnitsStr + 1
#define kCmStr					kInchStr + 1
#define kPixelStr				kCmStr + 1
#define kPicaStr				kPixelStr + 1
#define kDegreesStr				kPicaStr + 1
#define kRadiansStr				kDegreesStr + 1
#define kScaleSelectionStr		kRadiansStr + 1
#define kRoundCornersStr		kScaleSelectionStr + 1
#define kWindowsStr				kRoundCornersStr + 1
#define kShowPaletteStr			kWindowsStr + 1
#define kHidePaletteStr			kShowPaletteStr + 1
#define kShowPatternsStr		kHidePaletteStr + 1
#define kHidePatternsStr		kShowPatternsStr + 1
#define kShowToolsStr			kHidePatternsStr + 1
#define kHideToolsStr			kShowToolsStr + 1

#endif

