//========================================================================================
//
//	File:				FloatFrm.h
//	Release Version:	$ 1.0d11 $
//
//	Author:				Henri Lamiraux
//
//	Copyright:	 1993, 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FLOATFRM_H
#define FLOATFRM_H

// ----- Part Layer -----

#ifndef FWFRAME_H
#include "FWFrame.h"
#endif

// ----- OS Layer -----

#ifndef FWMAPING_H
#include "FWMaping.h"
#endif

//========================================================================================
// Forward Declaration
//========================================================================================

#if FW_LIB_EXPORT_PRAGMAS
#pragma import on
#endif
class FW_CLASS_ATTR FW_CMapping;
#if FW_LIB_EXPORT_PRAGMAS
#pragma import off
#endif

class FW_CLASS_ATTR CDrawPart;

//========================================================================================
// CFloatingWindowFrame
//========================================================================================

class FW_CLASS_ATTR CFloatingWindowFrame : public FW_CFrame
{
//----------------------------------------------------------------------------------------
// Initialization/destruction
//
public:		
	CFloatingWindowFrame(Environment* ev, ODFrame* odFrame, FW_CPresentation* presentation, CDrawPart* drawPart);
	virtual ~ CFloatingWindowFrame();

//----------------------------------------------------------------------------------------
// Inherited
//
public:	
	virtual void			FacetAdded(Environment* ev, ODFacet* facet);
	virtual void			FacetRemoved(Environment* ev, ODFacet* facet);
	
//----------------------------------------------------------------------------------------
// New API
//
protected:	
	void					EraseBackground(Environment* ev, FW_CFacetContext& fc);
	void					HideShowFloating(Environment* ev);
	
//----------------------------------------------------------------------------------------
// Data Members
//
protected:	
	CDrawPart*				fDrawPart;
	ODFacet*				fFacet;
	FW_CMapping				fMapping;
};

#endif