//========================================================================================
//
//	File:				PatFrame.h
//	Release Version:	$ 1.0d11 $
//
//	Author:				Henri Lamiraux
//
//	Copyright:	 1993, 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef PATFRAME_H
#define PATFRAME_H

#ifndef UTILS_H
#include "Utils.h"
#endif

// ----- OS Layer -----

#ifndef FLOATFRM_H
#include "FloatFrm.h"
#endif

//========================================================================================
// Forward Declaration
//========================================================================================

#if FW_LIB_EXPORT_PRAGMAS
#pragma import on
#endif
class FW_CLASS_ATTR FW_CFacetContext;
class FW_CLASS_ATTR FW_CColor;
class FW_CLASS_ATTR FW_CMouseEvent;
#if FW_LIB_EXPORT_PRAGMAS
#pragma import off
#endif

//========================================================================================
// Constants
//========================================================================================

const FW_CFixed kPatternCellSize = FW_IntToFixed(24);

//========================================================================================
// Class CPatternFrame
//========================================================================================

class FW_CLASS_ATTR CPatternFrame : public CFloatingWindowFrame
{
//----------------------------------------------------------------------------------------
// Initialization/destruction
//
public:		
	CPatternFrame(Environment* ev, ODFrame* odFrame, FW_CPresentation* presentation, CDrawPart* drawPart);
	virtual ~ CPatternFrame();

//----------------------------------------------------------------------------------------
// Inherited API
//
public:	
	virtual void 			Draw(Environment* ev, ODFacet* odFacet, ODShape* invalidShape);
	virtual FW_Boolean		DoMouseDown(Environment* ev, const FW_CMouseEvent& theMouseEvent);

	virtual void			FacetAdded(Environment* ev, ODFacet* facet);
	
//----------------------------------------------------------------------------------------
// Data Members
//
private:
	CGrid					fGrid;
};

#endif
