//========================================================================================
//
//	File:				RRectShp.h
//	Release Version:	$ 1.0d11 $
//
//	Author:				Henri Lamiraux
//
//	Copyright:	 1993, 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef RRECTSHP_H
#define RRECTSHP_H

#ifndef CONSTANT_H
#include "Constant.h"
#endif

#ifndef BASESHP_H
#include "BaseShp.h"
#endif

#ifndef BOUNDSHP_H
#include "BoundShp.h"
#endif

// ----- OS Layer -----

#ifndef FWPOINT_H
#include "FWPoint.h"
#endif

// ----- Foundation Layer -----

#ifndef FWRUNTYP_H
#include "FWRunTyp.h"
#endif

//========================================================================================
// Forward Declarations
//========================================================================================

/*#if FW_LIB_EXPORT_PRAGMAS
#pragma import on
#endif
class FW_CLASS_ATTR ODFacet;
class FW_CLASS_ATTR ODShape;
class FW_CLASS_ATTR CDrawPart;
class FW_CLASS_ATTR CDrawPublishLink;
class FW_CLASS_ATTR CDrawSubscribeLink;
class FW_CLASS_ATTR FW_CGraphicContext;
class FW_CLASS_ATTR FW_CMouseEvent;
class FW_CLASS_ATTR FW_CRectShape;
class FW_CLASS_ATTR FW_PInk;
class FW_CLASS_ATTR FW_PStyle;
class FW_CLASS_ATTR FW_CRect;
#if FW_LIB_EXPORT_PRAGMAS
#pragma import off
#endif

class FW_CLASS_ATTR CDrawFacetClipper;*/

//========================================================================================
// class CRoundRectShape
//========================================================================================

class FW_CLASS_ATTR CRoundRectShape : public CBoundedShape
{
public:
	FW_DECLARE_CLASS

public:
	CRoundRectShape();
	CRoundRectShape(FW_CReadableStream& archive);
	virtual ~CRoundRectShape();
		
	// ----- Shape -----
	virtual void		GetClipRegion(Environment* ev, ODShape* clipRegion);
	virtual ODShape*	CreateShapeOutline(Environment *ev);

	virtual FW_Boolean	HitTest(Environment *ev, FW_CGraphicContext& gc, const FW_CMouseEvent& theMouseEvent) const;
	virtual void		RenderShape(Environment* ev, ODFacet* facet, FW_CGraphicContext& gc);

	// ----- Archiving -----
	static void* 		Read(FW_CReadableStream& archive);
	virtual void		Flatten(FW_CWritableStream& archive);

private:
	virtual void		OutlineShape(FW_CGraphicContext& gc, const FW_PInk& ink, const FW_PStyle& style, const FW_CRect& rect);

private:
	FW_CPoint			fOvalSize;
};

#endif