//========================================================================================
//
//	File:				EmbedFra.h
//	Release Version:	$ 1.0d11 $
//
//	Author:				M.Boetcher
//
//	Copyright:	 1993, 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef EMBEDFRAME_H
#define EMBEDFRAME_H

// ----- Framework Includes -----

#ifndef FWFRMING_H
#include "FWFrming.h"
#endif

//========================================================================================
// Forward class declaration
//========================================================================================

class FW_CLASS_ATTR CEmbedPart;

//========================================================================================
// CLASS CEmbedFrame
//========================================================================================

class FW_CLASS_ATTR CEmbedFrame : public FW_CEmbeddingFrame
{
//----------------------------------------------------------------------------------------
//	Initialization/Destruction
//
  public:
	CEmbedFrame(Environment* ev, ODFrame* odFrame, FW_CPresentation* presentation, CEmbedPart* part);
	virtual ~CEmbedFrame();

//----------------------------------------------------------------------------------------
//	Inherited API
//
  public:
	virtual void 			Draw(Environment* ev, ODFacet* odFacet, ODShape* invalidShape);

	virtual FW_Boolean 		DoAdjustMenus(Environment* ev, 
										FW_CMenuBar* menuBar, 
										FW_Boolean hasMenuFocus, 
										FW_Boolean isRoot);

	virtual void 			EmbedSingleFrame(Environment* ev,
								  		ODPart* odEmbeddedPart, 
								  		ODFrame* odEmbeddedFrame,
								  		ODShape* suggestedFrameShape);

	virtual ODFacet*		CreateEmbeddedFacet(Environment* ev,
										ODFacet* embeddingFacet,
										FW_MProxy* proxy,
										ODFrame* embeddedFrame,
										ODShape* proposedClipShape);
										
	virtual void			FrameShapeChanged(Environment* ev);

	virtual FW_CEditCommand* NewEditCommand(Environment* ev, ODCommandID commandID);

	virtual FW_CDropCommand* NewDropCommand(Environment *ev,
											FW_CFrame* frame,
											ODDragItemIterator* dropInfo, 
											ODFacet* odFacet, 
											const FW_CPoint& dropPoint);

//----------------------------------------------------------------------------------------
//	Data Members
//
private:
	ODShape*				MakeFrameShape(Environment* ev);

//----------------------------------------------------------------------------------------
//	Data Members
//
  private:
	CEmbedPart*	fPart;
};

#endif
