//========================================================================================
//
//	File:				EmbedPar.h
//	Release Version:	$ 1.0d11 $
//
//	Author:				M.Boetcher
//
//	Copyright:	 1993, 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef EMBEDPART_H
#define EMBEDPART_H

// ----- Framework Includes -----

#ifndef FWPARTNG_H
#include "FWPartng.h"
#endif

//========================================================================================
// Forward class declaration
//========================================================================================

#if FW_LIB_EXPORT_PRAGMAS
#pragma import on
#endif
class FW_CLASS_ATTR FW_CPresentation;
#if FW_LIB_EXPORT_PRAGMAS
#pragma import off
#endif

class FW_CLASS_ATTR CEmbedFrame;
class FW_CLASS_ATTR CEmbedProxy;
class FW_CLASS_ATTR CEmbedSelection;

//========================================================================================
//	CLASS CEmbedPart
//========================================================================================

class FW_CLASS_ATTR CEmbedPart : public FW_CEmbeddingPart
{
//----------------------------------------------------------------------------------------
//	Initialization/Destruction
//
  public:
	CEmbedPart(ODPart* odPart);
	virtual void Initialize(Environment* ev);
	
	virtual ~CEmbedPart();
	
//----------------------------------------------------------------------------------------
//	Inherited API
//
  public:
	virtual FW_CFrame* NewFrame(Environment* ev,
								ODFrame* odFrame, 
								FW_CPresentation* presentation,
								FW_Boolean fromStorage);

	virtual void ExternalizeContent(Environment* ev, ODStorageUnit* storageUnit, FW_CCloneInfo* cloneInfo);
	virtual void InternalizeContent(Environment *ev, ODStorageUnit* storageUnit, FW_CCloneInfo* cloneInfo);

//----------------------------------------------------------------------------------------
//	New API
//
  public:
	CEmbedProxy* 				GetProxy(Environment* ev) const;
	void 						SetProxy(Environment* ev, CEmbedProxy* proxy);

	FW_CPresentation* 			GetMainPresentation(Environment* ev) const;

//----------------------------------------------------------------------------------------
//	Data Members
//
  public:
	static const ODValueType kPartKind;
	static const ODValueType kPartUserName;

  private:
	CEmbedSelection*	fSelection;
	FW_CPresentation*	fPresentation;
	CEmbedProxy*		fProxy;
};

//========================================================================================
//	CEmbedPart Inlines
//========================================================================================

inline FW_CPresentation* CEmbedPart::GetMainPresentation(Environment* ev) const
{
	return fPresentation;
}

//----------------------------------------------------------------------------------------
//	CEmbedPart::GetProxy
//----------------------------------------------------------------------------------------

inline CEmbedProxy* CEmbedPart::GetProxy(Environment* ev) const
{
	return fProxy;
}

#endif
