//========================================================================================
//
//	File:				EmbedSel.h
//	Release Version:	$ 1.0d11 $
//
//	Author:				M.Boetcher
//
//	Copyright:	 1993, 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef EMBEDSEL_H
#define EMBEDSEL_H

// ----- FrameWork Includes -----

#ifndef FWSLCING_H
#include "FWSlcing.h"
#endif

//========================================================================================
//	Forward Declarations
//========================================================================================

#if FW_LIB_EXPORT_PRAGMAS
#pragma import on
#endif
class FW_CLASS_ATTR FW_CCloneInfo;
#if FW_LIB_EXPORT_PRAGMAS
#pragma import off
#endif

class FW_CLASS_ATTR CEmbedPart;
class FW_CLASS_ATTR CEmbedProxy;

//========================================================================================
//	class CEmbedSelection
//========================================================================================

class FW_CLASS_ATTR CEmbedSelection : public FW_CEmbeddingSelection
{
	
//----------------------------------------------------------------------------------------
//	Initialization/Destruction
//
  public:
	CEmbedSelection(Environment* ev, CEmbedPart* embeddingPart);
	virtual ~CEmbedSelection();
	
//----------------------------------------------------------------------------------------
//	Inherited API
//
  public:
	virtual void		CloseSelection(Environment* ev);
	virtual FW_Boolean	ClearSelection(Environment* ev);
	virtual FW_Boolean	IsEmpty(Environment* ev) const;
	virtual void		SelectAll(Environment* ev);

	virtual FW_Boolean	DoInternalizeSelection(Environment* ev, 
											   ODStorageUnit* sourceSU, 
											   FW_CCloneInfo* cloneInfo);

	virtual FW_MProxy*	IsSelectionOnlyOneProxy(Environment* ev) const;
						
//----------------------------------------------------------------------------------------
//	New API
//
  public:
	void 				SetProxy(Environment* ev, CEmbedProxy* proxy);
	CEmbedProxy* 		GetProxy(Environment* ev) const;
								
//----------------------------------------------------------------------------------------
//	Data Members
//
  private:
	CEmbedPart*			fEmbeddingPart;
	CEmbedProxy*		fProxy;
};

//========================================================================================
//	CEmbedSelection Inlines
//========================================================================================

inline CEmbedProxy* CEmbedSelection::GetProxy(Environment* ev) const
{
	return fProxy;
}

#endif