//========================================================================================
//
//	File:				FormDef.h
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FORMDEF_H
#define FORMDEF_H

// Uncomment the following three lines, and define them appropriately!!
// If your part can be a container for other parts, define FW_SUPPORTS_EMBEDDING
// to be 1.  Otherwise define it to be 0.
// If your part defines any ODExtensions, define FW_SUPPORTS_EXTENSIONS to be
// 1 to enable the extensions manager.  Otherwise, define it to be 0.
// If your part is scriptable, define FW_SUPPORTS_SCRIPTING to be 1. Otherwise,
// define it to be zero.  Note that if your part is scriptable is must support
// extensions, so FW_SUPPORTS_EXTENSIONS must be defined to be 1.

#define FW_SUPPORTS_EMBEDDING 0
#define FW_SUPPORTS_EXTENSIONS 0
#define FW_SUPPORTS_SCRIPTING 0

#ifndef FW_SUPPORTS_EMBEDDING
#error You must define FW_SUPPORTS_EMBEDDING to be 0 or 1 (immediately above)
#endif

#ifndef FW_SUPPORTS_EXTENSIONS
#error You must define FW_SUPPORTS_EXTENSIONS to be 0 or 1 (immediately above)
#endif

#ifndef FW_SUPPORTS_SCRIPTING
#error You must define FW_SUPPORTS_SCRIPTING to be 0 or 1 (immediately above)
#endif

// Kind
#define kFormKind "+//ISO 9070/ANSI::113722::US::CI LABS::Apple:ODFExamples:Kind:ODFForm"

// Class ID
#define kFormEditor "ODFExamples::ODFForm"

// Editor User String
#define kFormEditorUserString "ODFForm 1.0d11"

// Kind User String
#define kFormKindUserString "ODF Form Example"

// Category User String
#define kFormCategoryUserString "Views"

// Form OSType
#define kFormOSType 'MKRD'

// Part Icon ID
#define kPartIconID 128

#define FW_kKindCategoryMapId		128
#define FW_kEditorKindMapId			FW_kKindCategoryMapId + 1
#define FW_kEditorUserStringMapId	FW_kEditorKindMapId + 1
#define FW_kKindUserStringMapId		FW_kEditorUserStringMapId + 1
#define FW_kCategoryUserStringMapId	FW_kKindUserStringMapId + 1
#define FW_kOldMacOSTypeMapId		FW_kCategoryUserStringMapId + 1
#define FW_kEditorPlatformKinds		FW_kOldMacOSTypeMapId + 1

// Menus
#define kFormMenu 5

// Strings
#define kFormPartStrings 1000

#define kFormMenuString 	1
#define kGreetMenuString 	2
#define kGoodbyeMenuString 	3
#define kFormString 		4
#define kGoodbyeString 		5
#define kMacString			6
#define kWinString			7

#ifdef FW_BUILD_MAC
#define kPlatformString 	kMacString
#endif
#ifdef FW_BUILD_WIN
#define kPlatformString 	kWinString
#endif

#define kAboutBoxStrings 1001

#define kAboutMenuString 1
#define kFormPartString 2
#define kCreditString 3

// About box Alert ID
#define kFormAboutBoxID  5000

#endif

