//========================================================================================
//
//	File:				FormView.h
//	Release Version:	$ 1.0d11 $
//
//	Author:				Laurent Delamare
//
//	Copyright:	 1993, 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FORMVIEW_H
#define FORMVIEW_H

// ----- Part Layer -----

#ifndef FWVIEW_H
#include "FWView.h"
#endif

//========================================================================================
// Forward Declaration
//========================================================================================

class FW_CLASS_ATTR CFormPart;

//========================================================================================
// CFormView
//========================================================================================
// View containing the scrolling form  (ContentView for this frame)

class FW_CLASS_ATTR CFormView : public FW_CView
{
public:
	FW_DECLARE_CLASS

//----------------------------------------------------------------------------------------
// Initialization/destruction
//
public:		
	CFormView(Environment *ev, FW_CView* container, FW_CRect& bounds, CFormPart* drawPart);
	virtual ~ CFormView();

//----------------------------------------------------------------------------------------
// Inherited API
//
public:		
	virtual void 			Draw(Environment *ev, ODFacet* odFacet, ODShape* invalidShape);
	virtual FW_Boolean 		DoMouseDown(Environment *ev, const FW_CMouseEvent& theMouseEvent);

//----------------------------------------------------------------------------------------
//	New API
//

//----------------------------------------------------------------------------------------
// Data Members
//
private:	
	CFormPart*				fFormPart;
};

#endif
