//========================================================================================
//
//	File:				Movie.r
//	Release Version:	$ 1.0d11 $
//
//	Written by:	Lonnie Millett
//
//	Copyright:	 1993, 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#define SystemSevenOrBetter 1			// we want the extended types
#define	SystemSevenOrLater	1			// Types.r uses this variable

#include "Types.r"
#include "SysTypes.r"
#include "CodeFragmentTypes.r"

#ifndef __ODTYPES_R__
#include "ODTypes.r"
#endif

#ifndef MOVIEDEF_H
	#include "MovieDef.h"
#endif

//-------------------------------------------------------------------------------------
// cfrg Resource
//-------------------------------------------------------------------------------------

resource 'cfrg' (0) {
	{	/* array memberArray: 2 elements */
		/* [1] */
#ifdef FW_BUILD_MAC68K
		kMotorola,
#else
		kPowerPC,
#endif
		kFullLib,
		kNoVersionNum,
		kNoVersionNum,
		kDefaultStackSize,
		kNoAppSubFolder,
		kIsLib,
		kOnDiskFlat,
		kZeroOffset,
		kWholeFork,
		kODFMovieEditor,
		/* [2] */
#ifdef FW_BUILD_MAC68K
		kMotorola,
#else
		kPowerPC,
#endif
		kFullLib,
		kNoVersionNum,
		kNoVersionNum,
		kDefaultStackSize,
		kNoAppSubFolder,
		kIsLib,
		kOnDiskFlat,
		kZeroOffset,
		kWholeFork,
		"ODFMovie"
	}
};

//-------------------------------------------------------------------------------------
// NMAP Resources
//-------------------------------------------------------------------------------------

resource kODNameMappings (kKindCategoryMapId) {
	kODKind,
	{	/* array Types: 1 elements */
		/* [1] */
		kODFMovieKind,
		kODIsAnISOStringList
		{
			{	/* array ClassIDs: 1 elements */
				/* [1] */
				kODCategoryMovie
			}
		}
	}
};

resource kODNameMappings (kEditorKindMapId) {
	kODEditorKinds,
	{	/* array Types: 1 elements */
		/* [1] */
		kODFMovieEditor,
		kODIsAnISOStringList
		{
			{	/* array ClassIDs: 1 elements */
				/* [1] */
				kODFMovieKind
			}
		}
	}
};

resource kODNameMappings (kEditorUserStringMapId) {
	kODEditorUserString,
	{	/* array Types: 1 elements */
		/* [1] */
		kODFMovieEditor,
		kODIsINTLText
		{
			smRoman,
			langEnglish,
			kODFMovieEditorUserString
		}
	}
};

resource kODNameMappings (kKindUserStringMapId) {
	kODKindUserString,
	{	/* array Types: 1 elements */
		/* [1] */
		kODFMovieKind,
		kODIsINTLText
		{
			smRoman,
			langEnglish,
			kODFMovieKindUserString
		}
	}
};

resource kODNameMappings (kCategoryUserStringMapId) {
	kODCategoryUserString,
	{	/* array Types: 1 elements */
		/* [1] */
		kODCategoryMovie,
		kODIsINTLText
		{
			smRoman,
			langEnglish,
			kODFMovieCategoryUserString
		}
	}
};

resource kODNameMappings (kOldMacOSTypeMapId) {
	kODKindOldMacOSType,
	{	/* array KeyList: 1 elements */
		/* [1] */
		kODFMovieKind,
		kODIsMacOSType {
			kODFMovieOSType
		}
	}
};

resource kODNameMappings (kEditorPlatformKinds) {
	kODEditorPlatformKind,
	{	/* array KeyList: 1 elements */
		/* [1] */
		kODFMovieEditor,
		kODIsPltfmTypeSpac {
			/* array PltfmTypeSpacList: 2 elements */
			{
				/* [1] */
				kODPlatformFileType, 
				kMooVOSType, 
				smRoman, 
				langEnglish, 
				kODFMovieEditorUserString1, 
				kODCategoryMovie,
				/* [2] */
				kODPlatformDataType, 
				kMooVOSType, 
				smRoman, 
				langEnglish, 
				kODFMovieEditorUserString2, 
				kODCategoryMovie
			}
		}
	}
};

include "MacIcons.rsrc" not 'ckid';
include "Image.Pict" not 'ckid';
