//========================================================================================
//
//	File:				Nothing.h
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	 1993, 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef NOTHING_H
#define NOTHING_H

// ----- Framework Includes -----

#ifndef FWFRAME_H
#include "FWFrame.h"
#endif

#ifndef FWPART_H
#include "FWPart.h"
#endif

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export on
#endif

//========================================================================================
//	CLASS CNothingPart
//========================================================================================

class FW_CLASS_ATTR CNothingPart : public FW_CPart
{
public:
	static const ODValueType kPartKind;
	static const ODValueType kPartUserName;
	
//----------------------------------------------------------------------------------------
//	Initialization/Destruction
//
public:
	CNothingPart(ODPart* odPart);
	virtual ~CNothingPart();

	virtual void Initialize(Environment* ev);
	
//----------------------------------------------------------------------------------------
//	Inherited API
//
public:
	virtual FW_CFrame* NewFrame(Environment* ev,
								ODFrame* odFrame, 
								FW_CPresentation* presentation,
								FW_Boolean fromStorage);
};

//========================================================================================
// CLASS CNothingFrame
//========================================================================================

class FW_CLASS_ATTR CNothingFrame : public FW_CFrame
{
//----------------------------------------------------------------------------------------
//	Initialization/Destruction
//
public:
	CNothingFrame(Environment* ev, ODFrame* odFrame, FW_CPresentation* presentation, FW_CPart* part);
	virtual ~CNothingFrame();

//----------------------------------------------------------------------------------------
//	Inherited API
//
public:
	virtual void Draw(Environment* ev, ODFacet* odFacet, ODShape* invalidShape);

};

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export off
#endif

#endif
