//========================================================================================
//
//	File:				TblPart.r
//	Release Version:	$ 1.0d11 $ 
//
//	Copyright:	 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#define SystemSevenOrBetter 1			// we want the extended types
#define	SystemSevenOrLater	1			// Types.r uses this variable

#include "Types.r"
#include "SysTypes.r"
#include "CodeFragmentTypes.r"

#ifndef __ODTYPES_R__
#include "ODTypes.r"
#endif

#ifndef TBLDEF_H
#include "TblDef.h"
#endif

//-------------------------------------------------------------------------------------
// cfrg Resource
//-------------------------------------------------------------------------------------

resource 'cfrg' (0) {
	{	/* array memberArray: 2 elements */
		/* [1] */
#ifdef FW_BUILD_MAC68K
		kMotorola,
#else
		kPowerPC,
#endif
		kFullLib,
		kNoVersionNum,
		kNoVersionNum,
		kDefaultStackSize,
		kNoAppSubFolder,
		kIsLib,
		kOnDiskFlat,
		kZeroOffset,
		kWholeFork,
		kODFTableEditor,
		/* [2] */
#ifdef FW_BUILD_MAC68K
		kMotorola,
#else
		kPowerPC,
#endif
		kFullLib,
		kNoVersionNum,
		kNoVersionNum,
		kDefaultStackSize,
		kNoAppSubFolder,
		kIsLib,
		kOnDiskFlat,
		kZeroOffset,
		kWholeFork,
		"ODFTable"
	}
};

//-------------------------------------------------------------------------------------
// NMAP Resources
//-------------------------------------------------------------------------------------

resource kODNameMappings (kKindCategoryMapId) {
	kODKind,
	{	/* array Types: 1 elements */
		/* [1] */
		kODFTableKind,
		kODIsAnISOStringList
		{
			{	/* array ClassIDs: 1 elements */
				/* [1] */
				kODCategoryTable
			}
		}
	}
};

resource kODNameMappings (kEditorKindMapId) {
	kODEditorKinds,
	{	/* array Types: 1 elements */
		/* [1] */
		kODFTableEditor,
		kODIsAnISOStringList
		{
			{	/* array ClassIDs: 1 elements */
				/* [1] */
				kODFTableKind
			}
		}
	}
};

resource kODNameMappings (kEditorUserStringMapId) {
	kODEditorUserString,
	{	/* array Types: 1 elements */
		/* [1] */
		kODFTableEditor,
		kODIsINTLText
		{
			smRoman,
			langEnglish,
			kODFTableEditorUserString
		}
	}
};

resource kODNameMappings (kKindUserStringMapId) {
	kODKindUserString,
	{	/* array Types: 1 elements */
		/* [1] */
		kODFTableKind,
		kODIsINTLText
		{
			smRoman,
			langEnglish,
			kODFTableKindUserString
		}
	}
};

resource kODNameMappings (kCategoryUserStringMapId) {
	kODCategoryUserString,
	{	/* array KeyList: 1 elements */
		/* [1] */
		kODCategoryTable,
		kODIsINTLText {
			smRoman,
			langEnglish,
			kODFTableCategoryUserString
		}
	}
};

resource kODNameMappings (kOldMacOSTypeMapId) {
	kODKindOldMacOSType,
	{	/* array KeyList: 1 elements */
		/* [1] */
		kODFTableKind,
		kODIsMacOSType {
			kODFTableOSType
		}
	}
};

//-------------------------------------------------------------------------------------
// .rsrc resources
//-------------------------------------------------------------------------------------

include "MacIcons.rsrc" not 'ckid';
