//========================================================================================
//
//	File:				FWEnvDef.h
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	(c) 1993, 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWENVDEF_H
#define FWENVDEF_H

//========================================================================================
// Definitions Specific to the Build Configuration
//========================================================================================

#ifndef FWBLDDEF_H
#include "FWBldDef.h"
#endif

//========================================================================================
// Metrowerks -- Macintosh
//========================================================================================

#ifdef __MWERKS__

	#define FW_BUILD_MAC
	#undef FW_BUILD_WIN
	#undef FW_BUILD_WIN16
	#undef FW_BUILD_WIN32
	#undef FW_BUILD_WIN32S
	
	#define ppcinterfaces 1
	#define OLDROUTINENAMES 		0
	#define OLDROUTINELOCATIONS 	0
	// Portablility defines for export mechanisms used by MS Windows compilers
	#define FW_CLASS_ATTR
	#define FW_FUNC_ATTR
	
	#ifndef FW_LIB_EXPORT_PRAGMAS
	#define FW_LIB_EXPORT_PRAGMAS 0
	#endif
	
	// Hack to control what is exported from a CFM shared lib on PPC. Define functions
	// with indicative names which CodeWarrior will place in the .exp file. The MPW tool
	// MWExportTool will then filter the .exp removing exports between off functions and
	// on functions, inclusive. The functions are dead-stripped since they are not exported
	// and never referenced.
	
	#define FW_EXPORT_ON(file, id) \
		extern "C" void _FW_export_lib_on_##file##id(); \
		extern "C" void _FW_export_lib_on_##file##id() { }
	#define FW_EXPORT_OFF(file, id) \
		extern "C" void _FW_export_lib_off_##file##id(); \
		extern "C" void _FW_export_lib_off_##file##id() { }
	
	// The runtime file that defines these also defines global new and delete. Here we supply
	// our own version of these so that we don't have to depend on a modified version of the 
	// CodeWarrior runtime library.
	
//	#define FW_OPERATOR_NEW_SIZE_T_VOIDSTAR
	#define FW_SET_NEW_HANDLER
	
	#define FW_FOUR_BYTE_INTS __fourbyteints__

	// Force PowerPC alignment
	#pragma options align=power

//========================================================================================
// Symantec C++ -- Macintosh
//========================================================================================
#elif defined SYMANTEC_CPLUS && !defined _WINDOWS
	
	#pragma options(system_includes_from_project_tree)
	
	#define FW_AGGRESSIVE_PRECOMPILE 1

	#ifndef FW_LIB_EXPORT_PRAGMAS
	#define FW_LIB_EXPORT_PRAGMAS 0
	#endif
	#define PRAGMA_LIB_EXPORT 1
	#define PRAGMA_IMPORT 1
	
	#ifndef SOMLINK
	#define SOMLINK
	#endif
	
	#ifndef SOMDLINK
	#define SOMDLINK
	#endif
	
	#define FW_BUILD_MAC
	#undef FW_BUILD_WIN
	#undef FW_BUILD_WIN16
	#undef FW_BUILD_WIN32
	#undef FW_BUILD_WIN32S
	
	#define ppcinterfaces 1
	#define OLDROUTINENAMES 0
	#define OLDROUTINELOCATIONS 	0
	
	// Portablility defines for export mechanisms used by MS Windows compilers
	#define FW_CLASS_ATTR
	#define FW_FUNC_ATTR
	
	#define FW_EXPORT_ON
	#define FW_EXPORT_OFF
	
	#ifndef FW_FOUR_BYTE_INTS
	#define FW_FOUR_BYTE_INTS __option(int_4)
	#endif

	// Force PowerPC alignment
	#pragma options align=power

//========================================================================================
// CFM 68K using Symantec SCpp (__SC__ would also catch SPM but that's listed above)
//========================================================================================
#elif defined __SC__ && !defined _WINDOWS
	
	#define FW_AGGRESSIVE_PRECOMPILE 1

	#ifndef FW_LIB_EXPORT_PRAGMAS
	#define FW_LIB_EXPORT_PRAGMAS 0
	#endif
	
	#ifndef SOMLINK
	#define SOMLINK
	#endif
	
	#ifndef SOMDLINK
	#define SOMDLINK
	#endif
	
	#define FW_BUILD_MAC
	#undef FW_BUILD_WIN
	#undef FW_BUILD_WIN16
	#undef FW_BUILD_WIN32
	#undef FW_BUILD_WIN32S
	
	#define ppcinterfaces 1
	#define OLDROUTINENAMES 0
	#define OLDROUTINELOCATIONS 	0
	
	// Portablility defines for export mechanisms used by MS Windows compilers
	#define FW_CLASS_ATTR
	#define FW_FUNC_ATTR
	
	#define FW_EXPORT_ON
	#define FW_EXPORT_OFF
	
	#ifndef FW_FOUR_BYTE_INTS
	#define FW_FOUR_BYTE_INTS __option(int_4)
	#endif
	
//========================================================================================
// Mr. C -- Macintosh
//========================================================================================
#elif defined __MRC__

	#ifndef FW_LIB_EXPORT_PRAGMAS
	#define FW_LIB_EXPORT_PRAGMAS 0
	#endif
	
	#define FW_BUILD_MAC
	#undef FW_BUILD_WIN
	#undef FW_BUILD_WIN16
	#undef FW_BUILD_WIN32
	#undef FW_BUILD_WIN32S
	
	#define ppcinterfaces 1
	#define OLDROUTINENAMES 		0
	#define OLDROUTINELOCATIONS 	0

	// Portablility defines for export mechanisms used by MS Windows compilers
	#define FW_CLASS_ATTR
	#define FW_FUNC_ATTR
	
	#define FW_EXPORT_ON
	#define FW_EXPORT_OFF
	
	#define FW_FOUR_BYTE_INTS 1

	// Force PowerPC alignment
	#pragma options align=power

//========================================================================================
// Microsoft Visual C++ - Windows
//========================================================================================
#elif defined _MSC_VER

	#ifdef _WINDOWS_
	#error Include FWEnvDef.h before including Windows.h
	#endif

	#define FW_BUILD_WIN
	#define FW_BUILD_WIN32
	#define FW_HAS_INSTANCE_DATA
	#define FW_NATIVE_EXCEPTIONS
	#define FW_SET_NEW_HANDLER

	#define FW_LIB_EXPORT_PRAGMAS		0
	#define FW_FOUR_BYTE_INTS			1

	#define STRICT

	#define PLATFORM_WINDOWS

	#include <windows.h>
	
	#pragma warning(disable:4080)		// Invalid name in segment pragma

//========================================================================================
// Symantec C++ - Windows
//========================================================================================
#elif defined __SC__ && defined _WINDOWS

	#ifdef _WINDOWS_
	#error Include FWEnvDef.h before including Windows.h
	#endif

	#define FW_BUILD_WIN
	#define FW_BUILD_WIN32
	#define FW_HAS_INSTANCE_DATA
	#define FW_NATIVE_EXCEPTIONS
	#define FW_SET_NEW_HANDLER

	#define FW_LIB_EXPORT_PRAGMAS		0
	#define FW_FOUR_BYTE_INTS			1
	#define FW_AGGRESIVE_PRECOMPILE 1

	#define STRICT

	#define PLATFORM_WINDOWS

	#include <windows.h>
	
	#define SOMLINK __stdcall
	#define SOMDLINK __stdcall

//========================================================================================
// Unsupported Compiler
//========================================================================================
#else

	#error Unsupported compiler

#endif

//========================================================================================
// Other Defines 
//========================================================================================
#ifdef FW_BUILD_MAC
	#ifndef _PLATFORM_MACINTOSH_
		#define _PLATFORM_MACINTOSH_ 		1
	#endif
	#ifndef PLATFORM_MACINTOSH
		#define PLATFORM_MACINTOSH 			1
	#endif
	#if !defined(FW_HAS_INSTANCE_DATA)
		#define FW_HAS_INSTANCE_DATA
	#endif
#endif

#ifdef FW_BUILD_WIN
	#ifndef PLATFORM_WINDOWS
		#define PLATFORM_WINDOWS	 		1
	#endif
#endif

#endif
