#ifndef FWPRFCNT_H
#define FWPRFCNT_H

//========================================================================================
//
//	File:				FWPrfCnt.h
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	(c) 1993, 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWSTDDEF_H
#include "FWStdDef.h"
#endif

#ifdef FW_PROFILE

#if defined(FW_BUILD_MAC) && !defined(__TIMER__)
#include <Timer.h>
#endif

#if defined(FW_BUILD_WIN) && !defined(_INC_WINDOWS)
#include <windows.h>
#endif

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export on
#endif

//========================================================================================
// CLASS FW_CPerformanceCounter
//========================================================================================

class FW_CLASS_ATTR FW_CPerformanceCounter
{
public:
// ---- Construction
	FW_CPerformanceCounter();
	~FW_CPerformanceCounter();
	
	void		EndCheckPoint();

// ----- Implementation
private:
	long			fResult;
#ifdef FW_BUILD_WIN
	LARGE_INTEGER	fWinBegin;
	LARGE_INTEGER	fWinEnd;
	static DWORD	gWinOverhead;
	static DWORD	gWinFreq;
#endif
#ifdef FW_BUILD_MAC
	TMTask			fMacTMTask;
	FW_Boolean		fMacIsInQueue;
	
	static long		gMacTMOverhead;
#endif
};

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export off
#endif

#endif

//========================================================================================
// Performance counter macros
//========================================================================================

#ifdef FW_PROFILE

#define	FW_PERF_CNT_BEGIN(name)		\
	FW_CPerformanceCounter perfCntObj##name;

#define	FW_PERF_CNT_END(name)		\
	perfCntObj##name.EndCheckPoint();

#else

#define	FW_PERF_CNT_BEGIN(name)		((void) 0)
#define	FW_PERF_CNT_END(name)		((void) 0)

#endif

#endif // FWPRFCNT_H
