//========================================================================================
//
//	File:				FWPriExc.h
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	(c) 1993, 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWPRIEXC_H
#define FWPRIEXC_H

#ifndef   FWEXCEPT_H
#include "FWExcept.h"
#endif

#ifndef FWEXCDEF_H
#include "FWExcDef.h"
#endif

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export on
#endif

typedef long FW_PlatformError;

//========================================================================================
//	CLASS FW_XException
//========================================================================================

class FW_CLASS_ATTR FW_XException FW_EXCEPTION_OBJECT
{
public:
	FW_DECLARE_EXCEPTION(FW_XException)

	virtual~ FW_XException();
	FW_XException(const FW_XException& exception);
	FW_XException(FW_PlatformError theError);

	FW_PlatformError GetPlatformError() const;

private:
	const FW_PlatformError fPlatformError;
};

const FW_PlatformError FW_xUnknownError = 1;

FW_FUNC_ATTR	void FW_Failure(FW_PlatformError error);
FW_FUNC_ATTR	void FW_FailOnError(FW_PlatformError error);

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export off
#endif

#endif
