#ifndef FWSPOSTE_H
#define FWSPOSTE_H
//========================================================================================
//
//	File:				FWSPostE.h
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	(c) 1993, 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#include "stddef.h"

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export on
#endif

class FW_CLASS_ATTR _FW_XException;

#ifdef FW_BUILD_MAC
#pragma options align=mac68k
#endif

#ifdef FW_BUILD_WIN
#pragma pack(push, 1)
#endif

// Globals for posted exceptions 
struct FW_SPrivPostedExceptionGlobals
{
	short 			gPending;
		// 1 if an exception is pending, 0 if not.

	_FW_XException*	gPostedException;
		// the exception buffer, allocated in constructor.

	short			gMaxPostedSize;
		// size of exception buffer.
		
	short			gInitialized;
		// Only one instance of this class should exist.
		// First instance sets gInitialized to 1.
		// A second attempt to create an instance will fail.
};

#ifdef FW_BUILD_MAC
#pragma options align=reset
#endif

#ifdef FW_BUILD_WIN
#pragma pack(pop)
#endif

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export off
#endif

#endif
