//========================================================================================
//
//	File:				FWPriExc.cpp
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	(c) 1993, 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#include "FWFound.hpp"

#ifndef FWPRIEXC_H
#include "FWPriExc.h"
#endif

#ifndef FWPRIDEB_H
#include "FWPriDeb.h"
#endif

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export on
#endif

#ifdef FW_BUILD_MAC
#pragma segment BEL
#endif

//========================================================================================
// CLASS FW_XException
//========================================================================================

#ifdef FW_NATIVE_EXCEPTIONS
FW_DEFINE_EXCEPTION_ROOT(FW_XException)
#else
FW_DEFINE_EXCEPTION(FW_XException, _FW_XException)
#endif

//----------------------------------------------------------------------------------------
//	FW_XException::FW_XException
//----------------------------------------------------------------------------------------

FW_XException::FW_XException(const FW_XException& exception) :
	fPlatformError(exception.fPlatformError)
{
	FW_ASSERT(fPlatformError != 0);
}

//----------------------------------------------------------------------------------------
//	FW_XException::FW_XException
//----------------------------------------------------------------------------------------

FW_XException::FW_XException(FW_PlatformError theError) :
	fPlatformError(theError == 0 ? FW_xUnknownError : theError)
{
	FW_ASSERT(fPlatformError != 0);
}

//----------------------------------------------------------------------------------------
//	FW_XException::GetPlatformError
//----------------------------------------------------------------------------------------

FW_PlatformError FW_XException::GetPlatformError(void) const
{
	return fPlatformError;
}

//----------------------------------------------------------------------------------------
//	FW_XException::~FW_XException
//----------------------------------------------------------------------------------------

FW_XException::~FW_XException()
{
}

//----------------------------------------------------------------------------------------
//	FW_FailOnError
//----------------------------------------------------------------------------------------

FW_FUNC_ATTR	void FW_FailOnError(FW_PlatformError error)
{
	if (error != 0)
		FW_THROW(FW_XException(error));
}

//----------------------------------------------------------------------------------------
//	FW_Failure
//----------------------------------------------------------------------------------------

FW_FUNC_ATTR	void FW_Failure(FW_PlatformError error)
{
	FW_ASSERT(error != 0);
	FW_THROW(FW_XException(error));
}

