//========================================================================================
//
//	File:				FWRefCnt.h
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	(c) 1993, 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWREFCNT_H
#define FWREFCNT_H

#ifndef FWRUNTYP_H
#include "FWRunTyp.h"
#endif

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export on
#endif

//========================================================================================
//	class FW_MRefCount
//========================================================================================

class FW_CLASS_ATTR FW_MRefCount
{
public:
	FW_DECLARE_CLASS

protected:
	FW_MRefCount();
	virtual ~FW_MRefCount();
	
public:
	virtual long	Release();
	virtual long	Acquire();

	long			GetRefCount();
	
private:	
	long			fRefCount;
};

//========================================================================================
//	Inlines
//========================================================================================

//----------------------------------------------------------------------------------------
//	FW_MRefCount::GetRefCount
//----------------------------------------------------------------------------------------

inline long FW_MRefCount::GetRefCount()
{
	return fRefCount;
}

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export off
#endif

#endif
