//========================================================================================
//
//	File:				FWRefCnt.cpp
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	(c) 1993, 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#include "FWFound.hpp"

#ifndef FWREFCNT_H
#include "FWRefCnt.h"
#endif

#ifndef FWDEBUG_H
#include "FWDebug.h"
#endif

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export on
#endif

//========================================================================================
// RunTime Info
//========================================================================================

FW_DEFINE_CLASS_M0(FW_MRefCount)

//========================================================================================
//	class FW_MRefCount
//========================================================================================

//----------------------------------------------------------------------------------------
//	FW_MRefCount::FW_MRefCount
//----------------------------------------------------------------------------------------

FW_MRefCount::FW_MRefCount() :
	fRefCount(1)
{
}

//----------------------------------------------------------------------------------------
//	FW_MRefCount::~FW_MRefCount
//----------------------------------------------------------------------------------------

FW_MRefCount::~FW_MRefCount()
{
}

//----------------------------------------------------------------------------------------
//	FW_MRefCount::Acquire
//----------------------------------------------------------------------------------------

long FW_MRefCount::Acquire()
{
	return ++fRefCount;
}

//----------------------------------------------------------------------------------------
//	FW_MRefCount::Release
//----------------------------------------------------------------------------------------

long FW_MRefCount::Release()
{
	FW_ASSERT(fRefCount > 0);
	
	long result = --fRefCount;
	
	if (result == 0)
		delete this;
	
	return result;
}
