//========================================================================================
//
//	File:				FWNew.h
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	(c) 1993, 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWNEW_H
#define FWNEW_H

#ifndef FWSTDDEF_H
#include "FWStdDef.h"
#endif

//========================================================================================
// Type definitions
//========================================================================================

typedef void (*FW_PFVV)();	
	// Pointer to function returning void.
	// Used with set_new_handler.  See ARM, pp 280-81.

#ifdef __MWERKS__

	// See ARM, pp 280-81.  We don't include <new.h> because under MW it includes
	// <string.h> which defines "class string" which conflicts with our definition.

extern FW_PFVV	set_new_handler(FW_PFVV handler);

extern void*	operator new(size_t size);
extern void		operator delete(void* block);

#elif defined _MSC_VER

extern FW_PFVV	set_new_handler(FW_PFVV handler);

#else

#include <new.h>

#endif

#endif // FWNEW_H
