//========================================================================================
//
//	File:				FWConnec.h
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	(c) 1993, 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWCONNEC_H
#define FWCONNEC_H

#ifndef FWSTDDEF_H
#include "FWStdDef.h"
#endif

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export on
#endif

//========================================================================================
// Foward declarations
//========================================================================================

class FW_CLASS_ATTR FW_CInterest;
class FW_CLASS_ATTR FW_CNotification;

//========================================================================================
// CLASS FW_CConnection
//========================================================================================

class FW_CLASS_ATTR FW_CConnection
{
public:
						FW_CConnection();\
	virtual			~FW_CConnection();
			
	virtual void		RemoveAllInterests() = 0;
	virtual void		RemoveInterest(const FW_CInterest& interest) = 0;
	
	virtual void		Notify(const FW_CNotification& notification,
							   const FW_CInterest& interest) = 0;
							   
	virtual void		Connect();
	virtual void		Disconnect();
	
	FW_Boolean			IsConnected() const;

private:
	FW_Boolean			fIsConnected;
};

inline FW_Boolean FW_CConnection::IsConnected() const
{
	return fIsConnected;
}

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export off
#endif

#endif
