//========================================================================================
//
//	File:				FWIntere.h
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	(c) 1993, 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWINTERE_H
#define FWINTERE_H

#ifndef FWSTDDEF_H
#include "FWStdDef.h"
#endif

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export on
#endif

//========================================================================================
// Forward declarations
//========================================================================================

class FW_CLASS_ATTR FW_MNotifier;

//========================================================================================
// CLASS FW_CInterest
//========================================================================================

class FW_CLASS_ATTR FW_CInterest
{
public:
						FW_CInterest();
						FW_CInterest(FW_MNotifier* notifier, const FW_TypeToken& name);
						FW_CInterest(const FW_CInterest& other);
	virtual				~FW_CInterest();
	
	FW_CInterest&		operator=(const FW_CInterest& other);
	FW_Boolean			operator==(const FW_CInterest& other) const;
	
	virtual FW_CInterest*		Copy() const;
	
	FW_TypeToken		GetName() const;
	FW_MNotifier*		GetNotifier() const;
	
private:
	FW_TypeToken		fName;
	FW_MNotifier*		fNotifier;
};

//----------------------------------------------------------------------------------------
// FW_CInterest::GetName
//----------------------------------------------------------------------------------------

inline FW_TypeToken FW_CInterest::GetName() const
{
	return fName;
}

//----------------------------------------------------------------------------------------
// FW_CInterest::GetNotifier
//----------------------------------------------------------------------------------------

inline FW_MNotifier* FW_CInterest::GetNotifier() const
{
	return fNotifier;
}

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export off
#endif

#endif
