//========================================================================================
//
//	File:				FWNotifn.h
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	(c) 1993, 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWNOTIFN_H
#define FWNOTIFN_H

#ifndef FWSTDDEF_H
#include "FWStdDef.h"
#endif

#ifndef FWINTERE_H
#include "FWIntere.h"
#endif

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export on
#endif

//========================================================================================
// Forward declarations
//========================================================================================

class FW_CLASS_ATTR FW_CInterest;
class FW_CLASS_ATTR FW_MNotifier;

//========================================================================================
// CLASS FW_CNotification
//========================================================================================

class FW_CLASS_ATTR FW_CNotification
{
public:
						FW_CNotification(const FW_CInterest& interest);
						FW_CNotification(const FW_CNotification& other);
	virtual			~FW_CNotification();
	
	FW_Boolean			operator==(const FW_CNotification& other);
	FW_CNotification&	operator=(const FW_CNotification& other);

	FW_CInterest*		GetInterest() const;
	FW_TypeToken		GetName() const;
	FW_MNotifier*		GetNotifier() const;

private:
	FW_CInterest*		fInterest;
};

//----------------------------------------------------------------------------------------
// FW_CNotification::GetInterest
//----------------------------------------------------------------------------------------

inline FW_CInterest* FW_CNotification::GetInterest() const
{
	return fInterest;
}

//----------------------------------------------------------------------------------------
// FW_CNotification::GetName
//----------------------------------------------------------------------------------------

inline FW_TypeToken FW_CNotification::GetName() const
{
	return fInterest->GetName();
}

//----------------------------------------------------------------------------------------
// FW_CNotification::GetInterest
//----------------------------------------------------------------------------------------

inline FW_MNotifier* FW_CNotification::GetNotifier() const
{
	return fInterest->GetNotifier();
}

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export off
#endif

#endif
