//========================================================================================
//
//	File:				FWIntere.cpp
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	(c) 1993, 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#include "FWFound.hpp"

#ifndef FWINTERE_H
#include "FWIntere.h"
#endif

#ifndef FWNOTIFR_H
#include "FWNotifr.h"
#endif

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export on
#endif

//========================================================================================
// CLASS FW_CInterest
//========================================================================================

//----------------------------------------------------------------------------------------
// FW_CInterest::FW_CInterest
//----------------------------------------------------------------------------------------

FW_CInterest::FW_CInterest() :
	fNotifier(NULL),
	fName(0)
{
}

//----------------------------------------------------------------------------------------
// FW_CInterest::FW_CInterest
//----------------------------------------------------------------------------------------

FW_CInterest::FW_CInterest(FW_MNotifier* notifier, const FW_TypeToken& name) :
	fNotifier(notifier),
	fName(name)
{
}

//----------------------------------------------------------------------------------------
// FW_CInterest::FW_CInterest
//----------------------------------------------------------------------------------------

FW_CInterest::FW_CInterest(const FW_CInterest& other) :
	fNotifier(other.fNotifier),
	fName(other.fName)
{
}

//----------------------------------------------------------------------------------------
// FW_CInterest::~FW_CInterest
//----------------------------------------------------------------------------------------

FW_CInterest::~FW_CInterest()
{
}

//----------------------------------------------------------------------------------------
// FW_CInterest::operator=
//----------------------------------------------------------------------------------------
	
FW_CInterest& FW_CInterest::operator=(const FW_CInterest& other)
{
	fNotifier = other.fNotifier;
	fName = other.fName;
	
	return *this;
}

//----------------------------------------------------------------------------------------
// FW_CInterest::operator==
//----------------------------------------------------------------------------------------

FW_Boolean FW_CInterest::operator==(const FW_CInterest& other) const
{
	return fNotifier == other.fNotifier && fName == other.fName;
}

//----------------------------------------------------------------------------------------
// FW_CInterest::Copy
//----------------------------------------------------------------------------------------

FW_CInterest* FW_CInterest::Copy() const
{
	return new FW_CInterest(*this);
}
