//========================================================================================
//
//	File:				FWNotifn.cpp
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	(c) 1993, 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#include "FWFound.hpp"

#ifndef FWNOTIFN_H
#include "FWNotifn.h"
#endif

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export on
#endif

//========================================================================================
// CLASS FW_CNotification
//========================================================================================

//----------------------------------------------------------------------------------------
// FW_CNotification::FW_CNotification
//----------------------------------------------------------------------------------------

FW_CNotification::FW_CNotification(const FW_CInterest& interest) :
	fInterest(interest.Copy())
{
}

//----------------------------------------------------------------------------------------
// FW_CNotification::FW_CNotification
//----------------------------------------------------------------------------------------

FW_CNotification::FW_CNotification(const FW_CNotification& other) :
	fInterest(other.fInterest)
{
}

//----------------------------------------------------------------------------------------
// FW_CNotification::~FW_CNotification
//----------------------------------------------------------------------------------------

FW_CNotification::~FW_CNotification()
{
}

//----------------------------------------------------------------------------------------
// FW_CNotification::operator==
//----------------------------------------------------------------------------------------

FW_Boolean FW_CNotification::operator==(const FW_CNotification& other)
{
	return *fInterest == *(other.fInterest);
}

//----------------------------------------------------------------------------------------
// FW_CNotification::operator=
//----------------------------------------------------------------------------------------

FW_CNotification& FW_CNotification::operator=(const FW_CNotification& other)
{
	fInterest = other.fInterest;
	return *this;
}

