//========================================================================================
//
//	File:				FWClaPrv.h
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	(c) 1993, 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWCLAPRV_H
#define FWCLAPRV_H

// ----- ODF RTTI private macros.
//       Clients should use the public RTTI macros defined in FWClaInf.h

#ifdef FW_CAN_EXPORT_DATA
	#define FW_CLASS_INFO_PTR(name) \
	    (&name::gClassInfo)
#else
	#define FW_CLASS_INFO_PTR(name) \
	    (&name::PrivStaticGetClassInfo())
#endif

#define _FW_CLASS_ANCESTORS(name) \
    name::gAncestors
		
#define _FW_CLASS_OFFSETS(name) \
    name::gAncestorOffsets
		
const unsigned long FW_kDummyAddress = 1024;
#define _FW_BASE_OFFSET(derived, base)	\
	(((char*)((base*)((derived*)FW_kDummyAddress))) - (char*)FW_kDummyAddress)


#ifdef FW_CAN_EXPORT_DATA
	#define _FW_DEFINE_CLASSINFO_OBJECT(name) 											\
	    const FW_CClassInfo FW_SHARED_MEMBER												\
			name::gClassInfo(#name, sizeof(name), _FW_CLASS_ANCESTORS(name), _FW_CLASS_OFFSETS(name));
#else
	#define _FW_DEFINE_CLASSINFO_OBJECT(name) 											\
	    const FW_CClassInfo FW_SHARED_MEMBER												\
			name::gClassInfo(#name, sizeof(name), name::PrivGetAncestors(), name::PrivGetAncestorOffsets());\
		FW_ClassInfoPtr name::PrivNonVirtualGetClassInfo(void) const	{ return &name::gClassInfo; }		\
		const FW_CClassInfo& name::PrivStaticGetClassInfo() { return name::gClassInfo; }		\
		const FW_ClassInfoPtr* name::PrivGetAncestors() { return name::gAncestors; }			\
		const size_t* name::PrivGetAncestorOffsets() { return name::gAncestorOffsets; }
#endif

#define _FW_CLASS_ANCESTORS_IMPLEMENT_M0(name) 											\
	const FW_ClassInfoPtr FW_SHARED_MEMBER _FW_CLASS_ANCESTORS(name)[] =				\
	{																					\
		0																				\
	};																					\
	const size_t FW_SHARED_MEMBER _FW_CLASS_OFFSETS(name)[] =								\
	{																					\
		0																				\
	};

#define _FW_CLASS_ANCESTORS_IMPLEMENT_M1(name, ancestor)								\
	const FW_ClassInfoPtr FW_SHARED_MEMBER _FW_CLASS_ANCESTORS(name)[] =				\
	{																					\
		FW_CLASS_INFO_PTR(ancestor),													\
		0																				\
	};																					\
	const size_t FW_SHARED_MEMBER _FW_CLASS_OFFSETS(name)[] =								\
	{																					\
		_FW_BASE_OFFSET(name, ancestor),												\
		0																				\
	};

#define _FW_CLASS_ANCESTORS_IMPLEMENT_M2(name, ancestor1, ancestor2)					\
	const FW_ClassInfoPtr FW_SHARED_MEMBER _FW_CLASS_ANCESTORS(name)[] =				\
	{																					\
		FW_CLASS_INFO_PTR(ancestor1),													\
		FW_CLASS_INFO_PTR(ancestor2),													\
		0																				\
	};																					\
	const size_t FW_SHARED_MEMBER _FW_CLASS_OFFSETS(name)[] =								\
	{																					\
		_FW_BASE_OFFSET(name, ancestor1),												\
		_FW_BASE_OFFSET(name, ancestor2),												\
		0																				\
	};


#define _FW_CLASS_ANCESTORS_IMPLEMENT_M3(name, ancestor1, ancestor2, ancestor3)			\
	const FW_ClassInfoPtr FW_SHARED_MEMBER _FW_CLASS_ANCESTORS(name)[] =				\
	{																					\
		FW_CLASS_INFO_PTR(ancestor1),													\
		FW_CLASS_INFO_PTR(ancestor2),													\
		FW_CLASS_INFO_PTR(ancestor3),													\
		0																				\
	};																					\
	const size_t FW_SHARED_MEMBER _FW_CLASS_OFFSETS(name)[] =								\
	{																					\
		_FW_BASE_OFFSET(name, ancestor1),												\
		_FW_BASE_OFFSET(name, ancestor2),												\
		_FW_BASE_OFFSET(name, ancestor3),												\
		0																				\
	};

#define _FW_CLASS_ANCESTORS_IMPLEMENT_M4(name, ancestor1, ancestor2, ancestor3, ancestor4)\
	const FW_ClassInfoPtr FW_SHARED_MEMBER _FW_CLASS_ANCESTORS(name)[] =				\
	{																					\
		FW_CLASS_INFO_PTR(ancestor1),													\
		FW_CLASS_INFO_PTR(ancestor2),													\
		FW_CLASS_INFO_PTR(ancestor3),													\
		FW_CLASS_INFO_PTR(ancestor4),													\
		0																				\
	};																					\
	const size_t FW_SHARED_MEMBER _FW_CLASS_OFFSETS(name)[] =								\
	{																					\
		_FW_BASE_OFFSET(name, ancestor1),												\
		_FW_BASE_OFFSET(name, ancestor2),												\
		_FW_BASE_OFFSET(name, ancestor3),												\
		_FW_BASE_OFFSET(name, ancestor4),												\
		0																				\
	};

#define _FW_CLASSINFO_ACCESSOR_MEMBERS(name)											\
    FW_ClassInfoPtr name::PrivVirtualGetClassInfo(void) const							\
    {																					\
		return FW_CLASS_INFO_PTR(name);												\
    }

#endif
