//========================================================================================
//
//	File:				FWFound.hpp
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	(c) 1993, 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWFOUND_HPP
#define FWFOUND_HPP

#ifndef FW_USE_PRECOMPILED_HEADERS
#define FW_USE_PRECOMPILED_HEADERS 0
#endif

// ----- Environment definition file must be first -----

#ifndef FWENVDEF_H
#include "FWEnvDef.h"
#endif

#if FW_USE_PRECOMPILED_HEADERS

// ----- C++ runtime Includes -----

#include <stddef.h>

// ----- Platform Includes -----

#if defined(FW_BUILD_WIN) && !defined(_INC_WINDOWS)
#include <Windows.h>
#endif

#if defined(FW_BUILD_WIN) && !defined(_INC_WINDOWSX)
#include <WindowsX.h>
#endif

#ifdef FW_BUILD_MAC
#include "FWUniHdr.h"
#endif

// ----- ODF Includes -----

// We consider precompiling headers in this layer for this layer aggressive,
// as opposed to just precompiling things this layer uses.

#ifdef FW_AGGRESSIVE_PRECOMPILE

#ifndef FWCOMMON_H
#include "FWCommon.h"
#endif

#ifndef FWDEBUG_H
#include "FWDebug.h"
#endif

#ifndef FWRUNTYP_H
#include "FWRunTyp.h"
#endif

#ifndef FWEXCLIB_H
#include "FWExcLib.h"
#endif

#ifndef FWMEMORY_H
#include "FWMemory.h"
#endif

#ifndef FWFOUNDU_H
#include "FWFoundU.h"
#endif

#ifndef FWSTREAM_H
#include "FWStream.h"
#endif

#ifndef FWCOLLEC_H
#include "FWCollec.h"
#endif

#ifndef FWNOTIFN_H
#include "FWNotifn.h"
#endif

#ifndef FWSTRING_H
#include "FWString.h"
#endif

#endif // FW_AGGRESSIVE_PRECOMPILE

#endif // FW_USE_PRECOMPILED_HEADERS

#endif // FWFOUND_HPP
