//========================================================================================
//
//	File:				FWButton.h
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWBUTTON_H
#define FWBUTTON_H

// ----- Foundation Includes -----

#ifndef FWNOTIFN_H
#include "FWNotifn.h"
#endif

#ifndef FWNOTIFR_H
#include "FWNotifr.h"
#endif

// ----- Framewrk Includes -----

#ifndef FWGADGET_H
#include "FWGadget.h"
#endif

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export on
#endif

//========================================================================================
//	CLASS FW_CButtonPressedNotification
//========================================================================================

class FW_CLASS_ATTR FW_CButtonPressedNotification : public FW_CNotification
{
public:
						FW_CButtonPressedNotification(const FW_CInterest& interest,
													  ODID buttonId, short buttonState);
						FW_CButtonPressedNotification(const FW_CButtonPressedNotification& other);
	virtual			~FW_CButtonPressedNotification();

	FW_Boolean						operator==(const FW_CButtonPressedNotification& other);
	FW_CButtonPressedNotification&	operator=(const FW_CButtonPressedNotification& other);
	
	ODID				GetButtonId() const;
	short				GetButtonState() const;
	
private:
	ODID				fButtonId;
	short				fButtonState;
};

//----------------------------------------------------------------------------------------
// FW_CButtonPressedNotification::GetButtonId
//----------------------------------------------------------------------------------------

inline ODID FW_CButtonPressedNotification::GetButtonId() const
{
	return fButtonId;
}

//----------------------------------------------------------------------------------------
// FW_CButtonPressedNotification::GetButtonState
//----------------------------------------------------------------------------------------

inline short FW_CButtonPressedNotification::GetButtonState() const
{
	return fButtonState;
}

//========================================================================================
//	CLASS FW_CButton
//========================================================================================

class FW_CLASS_ATTR FW_CButton : public FW_CGadget, public FW_MNotifier
{
// ----- Initialization/destruction
public:
	FW_DECLARE_CLASS

	FW_CButton(Environment* ev, 
			   FW_CView* container, ODID id,
			   const FW_CRect& bounds);
	FW_CButton(Environment* ev, FW_CReadableStream& archive);
	virtual ~FW_CButton();

// ----- Notification
	ODTypeToken					GetButtonPressedNotificationToken(Environment* ev) const;
	
// ----- Archiving -----
	virtual void				Flatten(FW_CWritableStream& archive) const;
	static void* 				Read(FW_CReadableStream& archive);
	
private:
	static const				ODType kButtonPressedNotification;
	ODTypeToken					fButtonPressedNotificationToken;
};

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export off
#endif

#endif
