//========================================================================================
//
//	File:				FWClustr.h
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWCLUSTR_H
#define FWCLUSTR_H

#ifndef FWGADGET_H
#include "FWGadget.h"
#endif

// ----- Foundation Layer -----

#ifndef FWRUNTYP_H
#include "FWRunTyp.h"
#endif

#ifndef FWSTRING_H
#include "FWString.h"
#endif

#ifndef FWHFCONN_H
#include "FWHFConn.h"
#endif

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export on
#endif

//========================================================================================
//	Foward class declarations
//========================================================================================

class FW_CLASS_ATTR FW_CMouseEvent;

//========================================================================================
//	CLASS FW_CRadioCluster
//========================================================================================

class FW_CLASS_ATTR FW_CRadioCluster : public FW_CGadget, FW_MReceiver
{
// ----- Initialization/destruction
public:
	FW_DECLARE_CLASS

	FW_CRadioCluster(Environment* ev, 
					 FW_CView* container, ODID id,
			   		 const FW_CRect& bounds, 
					 const FW_CString& label,
					 ODID buttonInitiallyOn);
	virtual ~FW_CRadioCluster();

// ----- Radio button management

	virtual void			ViewAdded(Environment* ev, FW_CGadget* gadget);
	virtual void			ViewRemoved(Environment* ev, const FW_CGadget& gadget);

	virtual void			SetButtonOn(Environment* ev, ODID buttonOnId);
	ODID					GetButtonOn(Environment* ev) const;

// ----- Update
public:
	virtual void 			Draw(Environment* ev, ODFacet* facet, ODShape* invalidShape);

// ----- Notifications

	virtual void 			HandleNotification(const FW_CNotification& notification);

private:
	FW_CDynamicString				fLabel;
	FW_CHandleFunctionConnection	fConnection;
	ODID							fButtonOnId;
};

//----------------------------------------------------------------------------------------
// FW_CRadioCluster::GetButtonOn
//----------------------------------------------------------------------------------------

inline ODID FW_CRadioCluster::GetButtonOn(Environment* ev) const
{
	return fButtonOnId;
}

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export off
#endif

#endif
