//========================================================================================
//
//	File:				FWClnInf.h
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWCLNINF_H
#define FWCLNINF_H

#ifndef FWSELECT_H
#include "FWSelect.h"
#endif

// ----- ODF Foundation Includes -----

#ifndef FWSTDEF_H
#include "FWStdDef.h"
#endif

#ifndef FWCLAINF_H
#include "FWClaInf.h"
#endif

#ifndef FWITERS_H
#include "FWIters.h"
#endif

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export on
#endif

//========================================================================================
//	Forward Declarations
//========================================================================================

class FW_CLASS_ATTR ODDraft;
class FW_CLASS_ATTR ODShape;

class FW_CLASS_ATTR FW_CPrivOrderedCollection;
class FW_CLASS_ATTR FW_CFrame;

//========================================================================================
//	class FW_CCloneInfo
//========================================================================================

class FW_CLASS_ATTR FW_CCloneInfo FW_AUTO_DESTRUCT_OBJECT
{
public:
	FW_CCloneInfo(Environment* ev,
				ODDraft* fromDraft, 
				FW_CFrame* scopeFrame, 
				ODCloneKind cloneKind);
	FW_CCloneInfo(Environment* ev,
				ODDraftKey key,
				ODDraft* fromDraft, 
				FW_CFrame* scopeFrame, 
				ODCloneKind cloneKind);
	~FW_CCloneInfo();

	void		BeginClone(Environment* ev, ODDraft* destinationDraft);
	void		EndClone(Environment* ev);
	void		AbortClone(Environment* ev);
	
	ODID		Clone(Environment* ev,
						ODID fromObjectID,
						ODID toObjectID,
						ODID scope);
	
	FW_CFrame*	GetScopeFrame(Environment* ev) const;
	ODCloneKind	GetCloneKind(Environment* ev) const;
	
public:
	FW_CPrivOrderedCollection*	fClonedProxyList;	// out	Cloning content
	ODID				fClonedPartID;				// out	Cloning part/Cloning Single Embedded Frame
	ODID				fClonedFrameID;				// out	Cloning Single Embedded Frame
	ODShape*			fFrameShape;				// out 	Cloning part/Cloning Single Embedded Frame

private:
	ODDraftKey 			fKey; 						// in
	ODDraft* 			fFromDraft; 				// in
	FW_CFrame* 			fScopeFrame;				// in
	ODCloneKind			fCloneKind;					// in
	FW_Boolean			fCloning;
	FW_Boolean			fBeganClone;
};

//----------------------------------------------------------------------------------------
//	FW_CCloneInfo::GetScopeFrame
//----------------------------------------------------------------------------------------
inline FW_CFrame* FW_CCloneInfo::GetScopeFrame(Environment* ev) const
{
	return fScopeFrame;
}

//----------------------------------------------------------------------------------------
//	FW_CCloneInfo::GetCloneKind
//----------------------------------------------------------------------------------------
inline ODCloneKind FW_CCloneInfo::GetCloneKind(Environment* ev) const
{
	return fCloneKind;
}

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export off
#endif

#endif

