//========================================================================================
//
//	File:				FWFrmInf.h
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWFRMINF_H
#define FWFRMINF_H

#ifndef FWEVENTH_H
#include "FWEventH.h"
#endif

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export on
#endif

//========================================================================================
//	Defines
//========================================================================================

#define FW_kODFFrameProperty "ODF:Property:Frame"
#define FW_kODFFrameValue "ODF:Value:Frame"

//========================================================================================
//	Forward Declaration
//========================================================================================

class FW_CLASS_ATTR FW_CFrame;

//========================================================================================
//	class FW_CFramePartInfo
//========================================================================================

class FW_CFramePartInfo : public FW_SEventHandlerPartInfo
{
public:
	FW_CFramePartInfo(Environment* ev, FW_CFrame* frame);
	~FW_CFramePartInfo();

	FW_CFrame*			GetFrame() const;	
	
private:
	FW_CFrame*			fFrame;
};

//----------------------------------------------------------------------------------------
//	FW_CFramePartInfo::GetFrame
//----------------------------------------------------------------------------------------
inline FW_CFrame* FW_CFramePartInfo::GetFrame() const
{
	return fFrame;
}

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export off
#endif

#endif