//========================================================================================
//
//	File:				FWIdle.h
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWIDLE_H
#define FWIDLE_H

// ----- Foundation Includes -----

#ifndef FWRUNTYP_H
#include "FWRunTyp.h"
#endif

// ----- OpenDoc Includes -----

#ifndef _ODTYPES_
#include <ODTypes.h>
#endif

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export on
#endif

//========================================================================================
//	Forward Declarations
//========================================================================================

class FW_CLASS_ATTR FW_CPart;
class FW_CLASS_ATTR FW_CFrame;

//========================================================================================
// class FW_MIdle
//========================================================================================

class FW_CLASS_ATTR FW_MIdle
{
public:
	FW_DECLARE_CLASS

//----------------------------------------------------------------------------------------
//	Initialization/Destruction
//
public:
	FW_MIdle(FW_CPart* part, FW_CFrame* frame);
	virtual ~FW_MIdle();

//----------------------------------------------------------------------------------------
//	API
//
public:
	void 				RegisterIdle(Environment *ev, ODIdleFrequency frequency);
	void 				UnregisterIdle(Environment *ev);
	
	void 				SetIdleFrequency(Environment *ev, ODIdleFrequency frequency);

	FW_Boolean			IsRegisteredForIdle(Environment *ev) const;

private:
	void				PrivRegisterIdle(Environment *ev, ODIdleFrequency frequency);
	void				PrivUnregisterIdle(Environment *ev);
	void				PrivSetIdleFrequency(Environment *ev, ODIdleFrequency frequency);

//----------------------------------------------------------------------------------------
//	Data Members
//
private:
	FW_Boolean	fRegistered;
	FW_CPart*	fPart;
	FW_CFrame*	fFrame;
};

//----------------------------------------------------------------------------------------
//	FW_MIdle::IsRegisteredForIdle
//----------------------------------------------------------------------------------------

inline FW_Boolean FW_MIdle::IsRegisteredForIdle(Environment *ev) const
{
	return fRegistered;
}

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export off
#endif

#endif