//========================================================================================
//
//	File:				FWPrstng.h
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWPRSTNG_H
#define FWPRSTNG_H

#ifndef FWPRESEN_H
#include "FWPresen.h"
#endif

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export on
#endif

//========================================================================================
//	Forward Declarations
//========================================================================================

class FW_CLASS_ATTR ODShape;
class FW_CLASS_ATTR ODPart;
class FW_CLASS_ATTR ODFrame;

class FW_CLASS_ATTR FW_CEmbeddingPart;
class FW_CLASS_ATTR FW_CEmbeddingSelection;
class FW_CLASS_ATTR FW_MProxy;

//========================================================================================
//	class FW_CEmbeddingPresentation
//========================================================================================

class FW_CLASS_ATTR FW_CEmbeddingPresentation : public FW_CPresentation
{
public:
	FW_DECLARE_CLASS

//----------------------------------------------------------------------------------------
//	Constructors/Destructors
//
public:
	FW_CEmbeddingPresentation(Environment *ev, 
					FW_CEmbeddingPart* thePart, 
					FW_CEmbeddingSelection* selection, 
					ODTypeToken presentationType,
					FW_Boolean sameViewTypeForEmbeddedFrames = TRUE);
	virtual ~FW_CEmbeddingPresentation();

//----------------------------------------------------------------------------------------
//	Inerited API
//
public:
	// ----- Embedding -----
	virtual void		Embed(Environment *ev, 
							ODPart *odEmbeddedPart,
							ODFrame* odEmbeddedFrame,		// Can be null
							FW_MProxy* proxy,
							ODShape* frameShape,
							ODTypeToken viewType,
							ODTypeToken presentationType,
							ODID frameGroupID,
							FW_Boolean subFrame);
	
};

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export off
#endif

#endif