//========================================================================================
//
//	File:				FWSclNot.h
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	 1993, 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWSCLNOT_H
#define FWSCLNOT_H

// ----- Foundation Layer -----

#ifndef FWNOTIFN_H
#include "FWNotifn.h"
#endif

// ----- OS Layer -----

#ifndef FWFXMATH_H
#include "FWFxMath.h"
#endif

// ----- OpenDoc Includes -----

#ifndef _ODTYPES_
#include <ODTypes.h>
#endif

//========================================================================================
//	CLASS FW_CScrollNotification
//========================================================================================

class FW_CLASS_ATTR FW_CScrollNotification : public FW_CNotification
{
public:
	enum Direction { kHorizontal, kVertical };

						FW_CScrollNotification(const FW_CInterest& interest,
											   Direction direction,
											   FW_CFixed absolute, 
											   FW_CFixed delta,
											   FW_Boolean shouldScroll = TRUE);
						FW_CScrollNotification(const FW_CScrollNotification& other);
	virtual				~FW_CScrollNotification();

	FW_Boolean					operator==(const FW_CScrollNotification& other);
	FW_CScrollNotification&		operator=(const FW_CScrollNotification& other);

	// ----- Notification name
	
	static const		ODType kName;
	
	// ----- Attributes
	
	Direction			GetDirection() const;
	FW_CFixed			GetDelta() const;
	FW_CFixed			GetAbsolute() const;
	FW_Boolean			ShouldScroll() const;

private:
	Direction			fDirection;
	FW_CFixed			fAbsolute;
	FW_CFixed			fDelta;
	FW_Boolean			fShouldScroll;
};

//----------------------------------------------------------------------------------------
// FW_CScrollNotification::GetDirection
//----------------------------------------------------------------------------------------

inline FW_CScrollNotification::Direction FW_CScrollNotification::GetDirection() const
{
	return fDirection;
}

//----------------------------------------------------------------------------------------
// FW_CScrollNotification::GetDelta
//----------------------------------------------------------------------------------------

inline FW_CFixed FW_CScrollNotification::GetDelta() const
{
	return fDelta;
}

//----------------------------------------------------------------------------------------
// FW_CScrollNotification::GetAbsolute
//----------------------------------------------------------------------------------------

inline FW_CFixed FW_CScrollNotification::GetAbsolute() const
{
	return fAbsolute;
}

//----------------------------------------------------------------------------------------
// FW_CScrollNotification::ShouldScroll
//----------------------------------------------------------------------------------------

inline FW_Boolean FW_CScrollNotification::ShouldScroll() const
{
	return fShouldScroll;
}

#endif
