//========================================================================================
//
//	File:				FWSlcing.h
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWSLCING_H
#define FWSLCING_H

#ifndef FWSELECT_H
#include "FWSelect.h"
#endif

#ifndef SOM_ODDraft_xh
#include <Draft.xh>
#endif

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export on
#endif

//========================================================================================
//	Forward Declarations
//========================================================================================

class FW_CLASS_ATTR ODStorageUnit;
class FW_CLASS_ATTR FW_CPart;
class FW_CLASS_ATTR FW_CFrame;
class FW_CLASS_ATTR ODShape;
class FW_CLASS_ATTR FW_MProxy;
class FW_CLASS_ATTR FW_CEmbeddingFrame;
class FW_CLASS_ATTR FW_CPrivOrderedCollection;

//========================================================================================
//	class FW_CEmbeddingSelection
//========================================================================================

class FW_CLASS_ATTR FW_CEmbeddingSelection : public FW_CSelection
{
public:
	FW_DECLARE_CLASS

//----------------------------------------------------------------------------------------
//	Initialization/Destruction
//
public:
	FW_CEmbeddingSelection(Environment* ev, FW_Boolean allowPublish, FW_Boolean allowSubscribe);
	virtual	~FW_CEmbeddingSelection();

//----------------------------------------------------------------------------------------
//	New API
//
public:
	virtual FW_MProxy*				IsSelectionOnlyOneProxy(Environment* ev) const;
	
	virtual FW_EInternalizeResult	DoInternalizeSingleEmbeddedFrame(Environment* ev, 
										ODStorageUnit* sourceSU, 
										FW_CCloneInfo* cloneInfo);
	virtual void					DoExternalizeSingleEmbeddedFrame(Environment* ev, 
										ODFrame* odEmbeddedFrame,
										ODStorageUnit* destinationSU, 
										FW_CCloneInfo* cloneInfo);
		
							
	// ----- Insert new Part -----
	virtual FW_Boolean 				InsertNewPart(Environment* ev, FW_CFrame* scopeFrame);
	
//----------------------------------------------------------------------------------------
//	For Internal Use Only
//
public:
	// ----- Externalize/Internalize Selection -----
	virtual void					PrivHandleExternalizeSelection(Environment* ev, 
										FW_EStorageKinds storageKind, 
										ODStorageUnit* storageUnit,
										FW_CCloneInfo* cloneInfo);
	virtual FW_EInternalizeResult	PrivHandleInternalizeSelection(Environment* ev, 
										ODStorageUnit* storageUnit,
										FW_CCloneInfo* cloneInfo);

	virtual void					PrivPostInternalizeSelection(Environment* ev, 
										FW_CCloneInfo* cloneInfo,
										FW_EInternalizeResult result);

protected:
	ODShape*						PrivReadFrameShape(Environment* ev, 
										ODStorageUnit* sourceSU);
	
	void							PrivPostInternalizeContent(Environment* ev, 
										FW_CCloneInfo* cloneInfo);								
	void							PrivPostInternalizeFrame(Environment* ev, 
										FW_CCloneInfo* cloneInfo);								
	void							PrivPostInternalizePart(Environment* ev, 
										FW_CCloneInfo* cloneInfo);								
};

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export off
#endif

#endif
