//========================================================================================
//
//	File:				FWSclNot.cpp
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	 1993, 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#include "FWFrameW.hpp"

#ifndef FWSCLNOT_H
#include "FWSclNot.h"
#endif

//========================================================================================
//	Runtime Info
//========================================================================================

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export on
#endif

#ifdef FW_BUILD_MAC
#pragma segment FW_FrameSegment
#endif

//========================================================================================
//	CLASS FW_CScrollNotification
//========================================================================================

const ODType FW_CScrollNotification::kName = "FW_CScrollNotification";

//----------------------------------------------------------------------------------------
// FW_CScrollNotification::FW_CScrollNotification
//----------------------------------------------------------------------------------------

FW_CScrollNotification::FW_CScrollNotification(const FW_CInterest& interest,
											   Direction direction,
											   FW_CFixed absolute, FW_CFixed delta,
											   FW_Boolean shouldScroll) :
	FW_CNotification(interest),
	fDirection(direction),
	fAbsolute(absolute),
	fDelta(delta),
	fShouldScroll(shouldScroll)
{
}

//----------------------------------------------------------------------------------------
// FW_CScrollNotification::FW_CScrollNotification
//----------------------------------------------------------------------------------------

FW_CScrollNotification::FW_CScrollNotification(const FW_CScrollNotification& other) :
	FW_CNotification(other),
	fDirection(other.fDirection),
	fAbsolute(other.fAbsolute),
	fDelta(other.fDelta),
	fShouldScroll(other.fShouldScroll)
{
}

//----------------------------------------------------------------------------------------
// FW_CScrollNotification::~FW_CScrollNotification
//----------------------------------------------------------------------------------------

FW_CScrollNotification::~FW_CScrollNotification()
{
}

//----------------------------------------------------------------------------------------
// FW_CScrollNotification::operator==
//----------------------------------------------------------------------------------------

FW_Boolean FW_CScrollNotification::operator==(const FW_CScrollNotification& other)
{
	return FW_CNotification::operator==(other) &&
				fDirection == other.fDirection &&
				fAbsolute == other.fAbsolute &&
				fDelta == other.fDelta &&
				fShouldScroll == other.fShouldScroll;
}

//----------------------------------------------------------------------------------------
// FW_CScrollNotification::operator=
//----------------------------------------------------------------------------------------

FW_CScrollNotification& FW_CScrollNotification::operator=(const FW_CScrollNotification& other)
{
	if (this == &other)
		return *this;

	FW_CNotification::operator=(other);
	fDirection = other.fDirection;
	fAbsolute = other.fAbsolute;
	fDelta = other.fDelta;
	fShouldScroll = other.fShouldScroll;

	return *this;
}
