//========================================================================================
//
//	File:				FWFrameW.hpp
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================
#ifndef FWFRAMEW_HPP
#define FWFRAMEW_HPP



#ifndef FW_USE_PRECOMPILED_HEADERS
#define FW_USE_PRECOMPILED_HEADERS 0
#endif

// ----- Precompiled header of next layer down -----

#ifndef FWOS_HPP
#include "FWOS.hpp"
#endif

#if FW_USE_PRECOMPILED_HEADERS

// ----- OS Includes -----

#ifndef FWFILES_H
#include "FWFiles.h"
#endif

#ifndef FWRESOUR_H
#include "FWResour.h"
#endif

#ifndef FWINTL_H
#include "FWIntl.h"
#endif

#ifndef FWEVENTS_H
#include "FWEvents.h"
#endif

#ifndef FWGRAPHX_H
#include "FWGraphx.h"
#endif

#ifndef FWMENU_H
#include "FWMenu.h"
#endif

#ifndef FWWINDOW_H
#include "FWWindow.h"
#endif

#ifndef FWOSMISC_H
#include "FWOSMisc.h"
#endif

#ifndef FWODUTIL_H
#include "FWODUtil.h"
#endif

// We consider precompiling headers in this layer for this layer aggressive,
// as opposed to just precompiling things this layer uses.

#ifdef FW_AGGRESSIVE_PRECOMPILE

#ifndef FWGADGTS_H
#include "FWGadgts.h"
#endif

// Our convention is that "FWPart.h" would be a 'master' include file for
// the subsystem FWPart.  Unfortunately, the FWPart subsystem currently doesn't
// follow the convention, and there is no such master include file.
// We therefore include each header file for the FWPart subsystem explicitly.

#ifndef FWABOUT_H
#include "FWAbout.h"
#endif

#ifndef FWCMD_H
#include "FWCmd.h"
#endif

#ifndef FWDRCMD_H
#include "FWDrCmd.h"
#endif

#ifndef FWDRGDRP_H
#include "FWDrgDrp.h"
#endif

#ifndef FWEDCMD_H
#include "FWEdCmd.h"
#endif

#ifndef FWFCTCLP_H
#include "FWFctClp.h"
#endif

#ifndef FWFRAME_H
#include "FWFrame.h"
#endif

#ifndef FWFRMINF_H
#include "FWFrmInf.h"
#endif

#ifndef FWFRMING_H
#include "FWFrming.h"
#endif

#ifndef FWIDLE_H
#include "FWIdle.h"
#endif

#ifndef FWITERS_H
#include "FWIters.h"
#endif

#ifndef FWLINK_H
#include "FWLink.h"
#endif

#ifndef FWPART_H
#include "FWPart.h"
#endif

#ifndef FWPRESEN_H
#include "FWPresen.h"
#endif

#ifndef FWPRMISE_H
#include "FWPrmise.h"
#endif

#ifndef FWPROXY_H
#include "FWProxy.h"
#endif

#ifndef FWPRTDEF_H
#include "FWPrtDef.h"
#endif

#ifndef FWPRTITE_H
#include "FWPrtIte.h"
#endif

#ifndef FWPXYFRM_H
#include "FWPxyFrm.h"
#endif

#ifndef FWSCLNOT_H
#include "FWSclNot.h"
#endif

#ifndef FWSCROLR_H
#include "FWScrolr.h"
#endif

#ifndef FWSELECT_H
#include "FWSelect.h"
#endif

#ifndef FWSLCING_H
#include "FWSlcing.h"
#endif

#ifndef FWTRACKR_H
#include "FWTrackr.h"
#endif

#ifndef FWUTIL_H
#include "FWUtil.h"
#endif

#ifndef FWCLNINF_H
#include "FWClnInf.h"
#endif

#ifndef FWPRSTNG_H
#include "FWPrstng.h"
#endif


#endif

// ----- OpenDoc Includes -----

#include <StdDefs.xh>		// Always need this one

// Generally we want the OpenDoc headers,
// but it can be convenient to turn them off.
// For now, we hand edit the following
// #if when we need to turn them off.

#if 1

// These are all of the OpenDoc Includes in the
// CPlusPlus folder as of OpenDoc 1.0f10.

#include <Arbitrat.xh>
#include <Canvas.xh>
#include <CanvasB.xh>
#include <Clipbd.xh>
#include <CmdDefs.xh>
#include <DgItmIt.xh>
#include <DispMod.xh>
#include <Disptch.xh>
#include <Document.xh>
#include <Draft.xh>
#include <DragDrp.xh>
#include <EmbFrItr.xh>
#include <ErrorDef.xh>
#include <Extensn.xh>
#include <Facet.xh>
#include <FacetItr.xh>
#include <Foci.xh>
#include <FocusItr.xh>
#include <FocusMod.xh>
#include <FocusOwn.xh>
#include <FocusSet.xh>
#include <Frame.xh>
#include <FrFaItr.xh>
#include <GeoTypes.xh>
#include <Info.xh>
#include <Link.xh>
#include <LinkB.xh>
#include <LinkMgr.xh>
#include <LinkSpcB.xh>
#include <LinkSpec.xh>
#include <LinkSrc.xh>
#include <LinkSrcB.xh>
#include <MenuBar.xh>
#include <MssgIntf.xh>
#include <NamRslvr.xh>
#include <NamSpac.xh>
#include <NmSpcMg.xh>
#include <ObjctItr.xh>
#include <ObjectNS.xh>
#include <ODAdrDes.xh>
#include <ODAplEvt.xh>
#include <ODBindng.xh>
#include <ODCtr.xh>
#include <ODDesc.xh>
#include <ODDesLst.xh>
#include <ODObject.xh>
#include <ODObjSpc.xh>
#include <ODOSLTkn.xh>
#include <ODRecord.xh>
#include <ODRgstry.xh>
#include <ODSessn.xh>
#include <ODSessnB.xh>
#include <ODStor.xh>
#include <ODTypesB.xh>
#include <ODTypesM.xh>
#include <Part.xh>
#include <PfTLItr.xh>
#include <PfTypLs.xh>
#include <Polygon.xh>
#include <PstObj.xh>
#include <RefCtObj.xh>
#include <SemtIntB.xh>
#include <Settings.xh>
#include <Shape.xh>
#include <ShapeB.xh>
#include <StdDefs.xh>
#include <StdExts.xh>
#include <StdProps.xh>
#include <StdTypes.xh>
#include <StorageU.xh>
#include <SUCursor.xh>
#include <SURefItr.xh>
#include <SUView.xh>
#include <Translt.xh>
#include <Trnsform.xh>
#include <TrnsfrmB.xh>
#include <TypeList.xh>
#include <TypLsItr.xh>
#include <Undo.xh>
#include <ValueItr.xh>
#include <ValueNS.xh>
#include <Window.xh>
#include <WinIter.xh>
#include <WinStat.xh>

#endif

#endif // FW_USE_PRECOMPILED_HEADERS

#endif // FWFRAMEW_HPP
