//========================================================================================
//
//	File:				FWFramwI.cpp
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	 1993, 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#include <som.xh>
#include <somobj.xh>

#ifndef FWCFMRES_H
#include "FWCFMRes.h"
#endif

#ifdef FW_DEBUG
	#ifndef FWEVENTU_H
	#include "FWEventU.h"
	#endif
#endif

#ifndef __CODEFRAGMENTS__
#include <CodeFragments.h>
#endif

//========================================================================================
// Runtime Informations
//========================================================================================

#ifdef FW_BUILD_MAC
#pragma segment framework
#endif

//========================================================================================
// Prototypes
//========================================================================================

#if defined(SYMANTEC_CPLUS) && defined(FW_BUILD_MAC)
	#define FW_FRAMEWRKCFMINIT PartCFMInit
	#define DummySOMInit main
	#if !FW_LIB_EXPORT_PRAGMAS
		#pragma internal on
	#endif
#endif

extern "C" pascal OSErr FW_FRAMEWRKCFMINIT (CFragInitBlockPtr initBlkPtr);

#if GENERATINGPOWERPC
#ifdef __MWERKS__
extern "C" void __sinit();
#elif defined __MRC__
extern "C" void __CPlusInit();
#endif
#endif

//========================================================================================
// Initialization functions
//========================================================================================

//----------------------------------------------------------------------------------------
// DummySOMInit
//----------------------------------------------------------------------------------------

SOMEXTERN void SOMLINK DummySOMInit (long majorVersion,
                                long minorVersion,
                                 string className);

SOMEXTERN void SOMLINK DummySOMInit (long majorVersion,
                                long minorVersion,
                                 string className)
{
} 

//----------------------------------------------------------------------------------------
// FW_FRAMEWRKCFMINIT
//----------------------------------------------------------------------------------------

extern "C" pascal OSErr FW_FRAMEWRKCFMINIT (CFragInitBlockPtr initBlkPtr)
{
#ifdef FW_DEBUG
	if (::FW_IsCommandKeyPressed())
		DebugStr("\pFW_FRAMEWRKCFMINIT");
#endif
	
	// Shared libraries don't get there static objects initialized correctly without
	// calling __sinit or __CPlusInit for MetroWerks or MrC respectively.

#if GENERATINGPOWERPC
#ifdef __MWERKS__
	__sinit();
#elif defined __MRC__
    __CPlusInit();
#endif
#endif
	
	return InitLibraryResources(initBlkPtr);
}
