//========================================================================================
//
//	File:				FWEventU.h
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWEVENTU_H
#define FWEVENTU_H

#ifndef FWSTDDEF_H
#include "FWStdDef.h"
#endif

#ifndef FWEVEDEF_H
#include "FWEveDef.h"
#endif

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export on
#endif

//========================================================================================
//	Forward Declarations
//========================================================================================

class FW_CLASS_ATTR ODWindow;
class FW_CLASS_ATTR ODFacet;
class FW_CLASS_ATTR FW_CPoint;
class FW_CLASS_ATTR FW_CGraphicContext;
struct FW_CLASS_ATTR Environment;

//========================================================================================
//	Global Utilities
//========================================================================================

//========================================================================================
//	Global Utilities
//========================================================================================

// ----- Key pressed
FW_Boolean FW_IsShiftKeyPressed();
FW_Boolean FW_IsOptionKeyPressed();
FW_Boolean FW_IsCommandKeyPressed();
FW_Boolean FW_IsControlKeyPressed();
FW_Boolean FW_FUNC_ATTR FW_IsKeyPressed(unsigned short theKey);

FW_CPoint	FW_FUNC_ATTR FW_GetMouseLocation(ODWindow* theODWindow, FW_CGraphicContext& theGC);
FW_CPoint	FW_FUNC_ATTR FW_GetMouseLocation(Environment* ev, ODFacet* facet);

FW_Boolean	FW_FUNC_ATTR FW_WaitMouseUp();

void		FW_FUNC_ATTR FW_WaitFor(long tickCount);

//========================================================================================
//	Global Inline Methods
//========================================================================================

//----------------------------------------------------------------------------------------
// ::FW_IsShiftKeyPressed
//----------------------------------------------------------------------------------------

inline FW_Boolean FW_IsShiftKeyPressed()
{
	return ::FW_IsKeyPressed(FW_SHIFT);
}

//----------------------------------------------------------------------------------------
// ::FW_IsCommandKeyPressed
//----------------------------------------------------------------------------------------

inline FW_Boolean FW_IsCommandKeyPressed()
{
	return ::FW_IsKeyPressed(FW_COMMAND);
}

//----------------------------------------------------------------------------------------
// ::FW_IsControlKeyPressed
//----------------------------------------------------------------------------------------

inline FW_Boolean FW_IsControlKeyPressed()
{
	return ::FW_IsKeyPressed(FW_CONTROL);
}

#ifdef FW_BUILD_MAC
//----------------------------------------------------------------------------------------
// ::FW_IsOptionKeyPressed
//----------------------------------------------------------------------------------------

inline FW_Boolean FW_IsOptionKeyPressed()
{
	return ::FW_IsKeyPressed(FW_OPTION);
}
#endif

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export off
#endif

#endif

