//========================================================================================
//
//	File:				FWFctInf.h
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWFCTINF_H
#define FWFCTINF_H

#ifndef FWGDEV_H
#include "FWGDev.h"
#endif

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export on
#endif

//========================================================================================
//	Forward class declaration
//========================================================================================

class FW_CLASS_ATTR ODFacet;

//========================================================================================
//	define
//========================================================================================

#define FW_kMagicNumber 0xABCD

//========================================================================================
//	class FW_CFacetPartInfo
//========================================================================================
//	FW_CFacetPartInfo is set in each one of our facet part info 

class FW_CLASS_ATTR FW_CFacetPartInfo
{
public:
	FW_CFacetPartInfo();
	virtual ~FW_CFacetPartInfo();
	
	void						InitFacetPartInfo(Environment* ev, ODFacet* facet);
	virtual FW_CGraphicDevice* 	GraphicDeviceFactory(Environment* ev, ODFacet* facet);
	
	static FW_CFacetPartInfo*	GetFacetPartInfo(Environment* ev, ODFacet* facet);

	static FW_CGraphicDevice* 	GetFacetGraphicDevice(Environment* ev, ODFacet* facet);

	FW_CGraphicDevice*			GetGraphicDevice(Environment* ev) const
									{return fDevice;}
	
private:	
	unsigned short			fMagicNumber;
	FW_CGraphicDevice*		fDevice;
};

//========================================================================================
//	Inlines
//========================================================================================

//----------------------------------------------------------------------------------------
//	FW_CFacetPartInfo::GetFacetGraphicDevice
//----------------------------------------------------------------------------------------
inline FW_CGraphicDevice* FW_CFacetPartInfo::GetFacetGraphicDevice(Environment* ev, ODFacet* facet)
{
	FW_CFacetPartInfo* partInfo = FW_CFacetPartInfo::GetFacetPartInfo(ev, facet);
	return partInfo ? partInfo->fDevice : NULL;
}

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export off
#endif

#endif
