//========================================================================================
//
//	File:				FWFontLi.h
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================


#ifndef FWFONTLI_H
#define FWFONTLI_H

// ----- Foundation Layer -----

#ifndef FWEXCLIB_H
#include "FWExcLib.h"
#endif

// ----- ODUtil -----

#ifndef FWORDCOL_H
#include "FWOrdCol.h"
#endif

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export on
#endif

//========================================================================================
// Forward declarations
//========================================================================================

class FW_CLASS_ATTR FW_CFontIterator;
class FW_CLASS_ATTR FW_CIntlString;

//========================================================================================
// CLASS FW_CFontList
//========================================================================================

class FW_CLASS_ATTR FW_CFontList FW_AUTO_DESTRUCT_OBJECT
{
public:
	FW_DECLARE_CLASS

public:
	FW_CFontList();
	virtual~FW_CFontList();

private:
	FW_CPrivOrderedCollection fFontList;
	
	friend FW_CFontIterator;
};

//========================================================================================
// CLASS FW_CFontInterator
//========================================================================================

class FW_CLASS_ATTR FW_CFontIterator FW_AUTO_DESTRUCT_OBJECT
{
public:
	FW_CFontIterator(); 
	FW_CFontIterator(FW_CFontList* fontList); 
	virtual ~FW_CFontIterator();

	FW_CIntlString	First();
		// Returns an empty string if the list is empty
	FW_CIntlString	Next();
		// Returns an empty string if at the end of the list
	FW_CIntlString	Last();
		// Returns an empty string if the list is empty
	FW_CIntlString	Previous();
		// Return an empty string if at the beginning of the list
	
	FW_Boolean			IsNotComplete();

private:
	FW_CFontList*	fFontList;
	FW_Boolean		fDeleteTheList;
	FW_COrderedCollectionIterator* fIterator;
};

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export off
#endif

#endif


