//========================================================================================
//
//	File:				FWGrDef.h
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	 1993, 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWGRDEF_H
#define FWGRDEF_H

#ifndef FWSTDDEF_H
#include "FWStdDef.h"
#endif

// ----- OpenDoc Includes -----

#if !defined(_QDFIX_) && defined(FW_BUILD_MAC)
#include <QDFixM.h>
#endif

// ----- Platform Includes -----

#if !defined(__TYPES__) && defined(FW_BUILD_MAC)
#include <Types.h>
#endif

#if !defined(__LOWMEM__) && defined(FW_BUILD_MAC)
#include <LowMem.h>
#endif

#if !defined(__QUICKDRAW__) && defined(FW_BUILD_MAC)
#include <Quickdraw.h>
#endif

#if defined(FW_BUILD_WIN) && !defined(_INC_WINDOWS)
#include <windows.h>
#endif

#if defined(FW_BUILD_MAC) && !defined(__QDOFFSCREEN__)
#include <QDOffScreen.h>
#endif

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export on
#endif

#ifdef FW_BUILD_MAC
typedef	PicHandle				FW_PlatformPict;
typedef	GWorldPtr				FW_PlatformBitmap;
typedef	Handle					FW_PlatformIcon;		// Icon suite
#endif

#ifdef FW_BUILD_WIN
typedef	HENHMETAFILE			FW_PlatformPict;
typedef	HBITMAP					FW_PlatformBitmap;
typedef	HICON					FW_PlatformIcon;
#endif

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export off
#endif

//========================================================================================
//	Forward class declarations
//========================================================================================

class FW_CLASS_ATTR FW_CGraphicContext;

//========================================================================================
//	struct FW_SDeviceState
//========================================================================================

struct FW_SDeviceState
{
#ifdef FW_BUILD_WIN
	POINT					fWindOrg;
	WORD					fMapMode;
#endif
#ifdef FW_BUILD_MAC
	// ----- if our port is not the current port fPreviousPlatformCanvas != NULL -----
	ODPlatformCanvas		fPreviousPlatformCanvas;
	
	// ----- if our port was the current port (fPreviousPlatformCanvas==NULL) save its state below -----
	ODRgnHandle				fClip;
	Point					fOrigin;
	
	FW_Boolean				fSuspended;

	FW_CGraphicContext*		fSavedContext;
#endif
};

//========================================================================================
//	struct FW_SSuspendResumeState
//========================================================================================

#ifdef FW_BUILD_WIN
struct FW_SSuspendResumeState
{
	int						fSavedDC;
	FW_CGraphicContext*		fSavedContext;
};
#endif

#ifdef FW_BUILD_MAC
#define FW_SSuspendResumeState	FW_SDeviceState
#endif

#endif
