#ifndef FWMDASH_H
#define FWMDASH_H

//========================================================================================
//
//	File:				FWMDash.h
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifdef FW_BUILD_MAC		// Macintosh-only

//========================================================================================
//	Header files
//========================================================================================

#ifndef _ODMATH_
#include <ODMath.h>
#endif

#ifndef FWGCONST_H
#include "FWGConst.h"
#endif

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export on
#endif

//========================================================================================
//	class FW_PBitmap
//========================================================================================

class FW_CLASS_ATTR FW_CMacDashDraw
{
public:

// ----- Construction

	FW_CMacDashDraw(FW_EStyleDash dash);
	~FW_CMacDashDraw();

// ----- Operations

	void	LineTo(short x, short y);

// ----- Implementation

private:
	short		fDashCount;
	short*		fDashDistances;
	FW_Boolean	fIsOpaque;
	
	RGBColor	fForeColor, fBackColor;
	
	short		fCurSegN;
	short		fCurSegDraw;
	
	short		fAdjustH;
	short		fAdjustV;

	void		InitAdjust(short dh, short dv);
	void		DrawOneSegment(short h, short v);
};

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export off
#endif

#endif // FW_BUILD_MAC

#endif // FWMDASH_H

