//========================================================================================
//
//	File:				FWOvlShp.h
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	 1993, 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWOVLSHP_H
#define FWOVLSHP_H

#ifndef FWSHAPE_H
#include "FWShape.h"
#endif

#ifndef FWBNDSHP_H
#include "FWBndShp.h"
#endif

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export on
#endif

//========================================================================================
//	Forward Declarations
//========================================================================================

class FW_CLASS_ATTR FW_CGraphicContext;

//========================================================================================
//	class FW_COvalShapeRep
//========================================================================================

class FW_CLASS_ATTR FW_COvalShape : public FW_CBoundedShape
{
public:
	FW_DECLARE_CLASS

//----------------------------------------------------------------------------------------
//	Constructors/Destructors
//
public:
	FW_COvalShape(const FW_CRect& rect,
			      FW_ERenderVerbs renderVerb,
				  const FW_PInk& ink = FW_kNormalInk,
				  const FW_PStyle& style = FW_kNormalStyle);

	FW_COvalShape(const FW_COvalShape& other);
	FW_COvalShape(FW_CReadableStream& archive);
	
	virtual ~ FW_COvalShape();
	
//----------------------------------------------------------------------------------------
//	Inherited API
//
public:
	// ----- Hit Testing -----
	virtual FW_Boolean HitTest(FW_CGraphicContext& gc,
								const FW_CPoint& test,
								FW_CFixed tolerance) const;

	// ----- Copying -----
	virtual FW_CShape*			Copy() const;
	
	// ----- Rendering -----
	virtual void 				Render(FW_CGraphicContext& gc) const;
	
//----------------------------------------------------------------------------------------
//	New API
//
public:
	// ----- Geometry -----
	void			GetGeometry(FW_CRect& rect) const
						{rect = fRect;}
	void			SetGeometry(const FW_CRect& rect)
						{fRect = rect;}

	// ----- Rendering -----
	static void	RenderOval(FW_CGraphicContext& gc,
								const FW_CRect& rect, 
								FW_ERenderVerbs renderVerb,
								const FW_PInk& ink = FW_kNormalInk,
								const FW_PStyle& style = FW_kNormalStyle);

	// ----- Archiving -----
	static void*	Read(FW_CReadableStream& archive);
};

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export off
#endif

#endif
