//========================================================================================
//
//	File:				FWPalete.h
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	 1993, 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWPALETE_H
#define FWPALETE_H

#ifndef FWCOLOR_H
#include "FWColor.h"
#endif

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export on
#endif

//========================================================================================
//	Palette type
//========================================================================================

#ifdef FW_BUILD_WIN
typedef HPALETTE	FW_Palette;
#endif

#ifdef FW_BUILD_MAC
typedef CTabHandle	FW_Palette;
#endif

//========================================================================================
//	Palette functions
//========================================================================================

FW_FUNC_ATTR	FW_Palette	FW_CreatePalette(
								short nSize,
								const FW_CColor* colors,
								short		nColorCount);

FW_FUNC_ATTR	short		FW_GetPaletteSize(FW_Palette palette);

FW_FUNC_ATTR	void		FW_SetPaletteEntries(
								FW_Palette	palette,
								const FW_CColor* colors,
								short		nStartIndex,
								short		nColorCount);

FW_FUNC_ATTR	void		FW_GetPaletteEntries(
								FW_Palette	palette,
								FW_CColor*	colors,
								short		nStartIndex,
								short		nColorCount);

FW_FUNC_ATTR	FW_Palette	FW_CopyPalette(FW_Palette palette);

FW_FUNC_ATTR	void		FW_DestroyPalete(FW_Palette palette);
								
#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export off
#endif

#endif // FWPALETE_H
