#ifndef FWSCRCON_H
#define FWSCRCON_H

//========================================================================================
//
//	File:				FWScrCon.h
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWGROBJ_H
#include "FWGrObj.h"
#endif

#ifndef FWGC_H
#include "FWGC.h"
#endif

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export on
#endif

//========================================================================================
//	Forward Class Declarations
//========================================================================================

class FW_CLASS_ATTR FW_CScreenContext;
class FW_CLASS_ATTR FW_CGraphicDevice;

//========================================================================================
//	class FW_CScreenContext
//========================================================================================

class FW_CLASS_ATTR FW_CScreenContext : public FW_CGraphicContext
{
public:
	FW_CScreenContext(Environment* ev,
					  ODShape* clipShape = NULL,
					  ODTransform* transform = NULL);
	virtual ~FW_CScreenContext();
	
private:
#ifdef FW_BUILD_WIN
	HDC fDC;
#endif
#ifdef FW_BUILD_MAC
	CGrafPort fCGrafPort;
#endif
	FW_CGraphicDevice* fGraphicDevice;
};

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export off
#endif

#endif // FWSCRCON_H
