//========================================================================================
//
//	File:		FWResSin.h
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWRESSIN_H
#define FWRESSIN_H

#ifndef FWRESACC_H
#include "FWResAcc.h"
#endif

#ifndef FWASINKS_H
#include "FWASinks.h"
#endif

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export on
#endif

//========================================================================================
//	CLASS FW_CResourceSink
//========================================================================================

class FW_CLASS_ATTR FW_CResourceSink : public FW_CRandomAccessSink
{

public:

	FW_CResourceSink(FW_CResource& resource);
	virtual ~ FW_CResourceSink();
	
	virtual void Read(void * destination, long count);
	
	virtual long GetWritableBytes() const;
	virtual void Write(const void* source, long count);

	virtual long GetLength() const;
	virtual void SetLength(long length);
	virtual long GetPosition() const;
	virtual void SetPosition(long position);
	
private:
	FW_CResource	fResource;
	FW_CMemorySink	fMemorySink;
	
	FW_CResourceSink(const FW_CResourceSink& sink);
	FW_CResourceSink& operator=(const FW_CResourceSink& sink);
		// Shouldn't copy this class.
};

#if FW_LIB_EXPORT_PRAGMAS
#pragma lib_export off
#endif

#endif
