//========================================================================================
//
//	File:				FWWinPro.h
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	 1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWWINPRO_H
#define FWWINPRO_H

#if FW_OPENDOC_VERSION >= FW_OPENDOC_DR2

// ----- Foundation Layer -----

#ifndef FWAUTODE_H
#include "FWAutoDe.h"
#endif

#ifndef FWRECT_H
#include "FWRect.h"
#endif

//========================================================================================
//	Forward Declarations
//========================================================================================

class FW_CLASS_ATTR ODFrame;
class FW_CLASS_ATTR ODWindow;

//========================================================================================
//	class FW_CWindowProperties
//========================================================================================
// Obtains window properties from the storage unit referred to in the frame's
// kODPropWindowProperties.

class FW_CWindowProperties FW_AUTO_DESTRUCT_OBJECT
{
//----------------------------------------------------------------------------------------
//	Constructor/Destructor
//
public:
	FW_CWindowProperties(Environment* ev);
	~FW_CWindowProperties();

	FW_Boolean		ReadWindowProperties(Environment* ev, ODFrame* frame);

private:
	void 			PrivInitProperties(Environment* ev);
	
//----------------------------------------------------------------------------------------
//	Data Members
//
public:
	FW_Boolean			fHasWindowProperties;
	
#ifdef FW_BUILD_MAC
	short  				fMacProcID;
	FW_Boolean 			fMacHasCloseBox;
	long   				fMacRefCon;
	Str255 				fMacTitle;
#endif

	FW_CRect 			fBoundsRect;
	FW_Boolean 			fIsResizable;
	FW_Boolean 			fWasVisible;
	FW_Boolean 			fIsFloating;
	FW_Boolean 			fIsRootWindow;
	FW_Boolean 			fShouldShowLinks;
	ODFrame*  			fSourceFrame;
};

#endif

#endif
