//========================================================================================
//
//	File:		FWOS.hpp
//	Release Version:	$ 1.0d11 $
//
//	Copyright:	1995 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWOS_HPP
#define FWOS_HPP

#ifndef FW_USE_PRECOMPILED_HEADERS
#define FW_USE_PRECOMPILED_HEADERS 0
#endif

// NOTICE: This include needs to be first because it defines the SOMCHKEXCEPT
// which the SOM generated C++ binding classes use to check and throw our
// kind of exceptions.

#ifndef FWODEXCE_H
#include "FWODExce.h"
#endif

#if FW_USE_PRECOMPILED_HEADERS

// ----- ODF (Foundation) Includes -----

#ifndef FWCOMMON_H
#include "FWCommon.h"
#endif

#ifndef FWMEMORY_H
#include "FWMemory.h"
#endif

#ifndef FWSTRING_H
#include "FWString.h"
#endif

#ifndef FWSTREAM_H
#include "FWStream.h"
#endif

#ifndef FWFOUNDU_H
#include "FWFoundU.h"
#endif

#ifndef FWEXCLIB_H
#include "FWExcLib.h"
#endif

#ifndef FWRUNTYP_H
#include "FWRunTyp.h"
#endif

#ifndef FWDEBUG_H
#include "FWDebug.h"
#endif

#ifndef FWCOLLEC_H
#include "FWCollec.h"
#endif

#ifndef FWNOTIFN_H
#include "FWNotifn.h"
#endif

// ----- ODF (OS) Includes -----

// We consider precompiling headers in this layer for this layer aggressive,
// as opposed to just precompiling things this layer uses.

#ifdef FW_AGGRESSIVE_PRECOMPILE

#ifndef FWFILES_H
#include "FWFiles.h"
#endif

#ifndef FWRESOUR_H
#include "FWResour.h"
#endif

#ifndef FWINTL_H
#include "FWIntl.h"
#endif

#ifndef FWEVENTS_H
#include "FWEvents.h"
#endif

#ifndef FWGRAPHX_H
#include "FWGraphx.h"
#endif

#ifndef FWMENU_H
#include "FWMenu.h"
#endif

#ifndef FWWINDOW_H
#include "FWWindow.h"
#endif

#ifndef FWOSMISC_H
#include "FWOSMisc.h"
#endif

#ifndef FWODUTIL_H
#include "FWODUtil.h"
#endif

#endif // FW_AGGRESSIVE_PRECOMPILE

// ----- OpenDoc Includes -----

#ifndef _ODTYPES_
#include <ODTypes.h>
#endif

#ifndef SOM_ODShape_xh
#include <Shape.xh>
#endif

#ifndef SOM_ODTransform_xh
#include <Trnsform.xh>
#endif

#ifndef SOM_ODCanvas_xh
#include <Canvas.xh>
#endif

#ifndef SOM_ODFacet_xh
#include <Facet.xh>
#endif

#ifndef SOM_ODWindow_xh
#include <Window.xh>
#endif

#ifndef SOM_ODPersistentObject_xh
#include <PstObj.xh>
#endif

#endif // FW_USE_PRECOMPILED_HEADERS

#endif // FWOS_HPP


